﻿;==============================================================================================================================================================================
; Close the window And reset the mutex
;==============================================================================================================================================================================

Procedure CloseMyWindow(WindowId.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Remove hover events for passed windows
  ;------------------------------------------------------------------------------------------------
  
  Select WindowId.i

    ;----------------------------------------------------------------------------------------------
    ; All cleanup for this window happen at program end
    ;----------------------------------------------------------------------------------------------

    Case #Window_Mystuff
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(#Gadget_Mystuff_Addnewstuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Copyoldstuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Deleteoldstuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Editthistuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Killthisstuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Lockthisstuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Favouritestuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Printthisstuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Exportmystuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Importmystuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Helpwithstuff)
      
      RemoveHoverGadget(#Gadget_Mystuff_Exitthisstuff)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_Location
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(#Gadget_Location_Save)
      
      RemoveHoverGadget(#Gadget_Location_Exit)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_Datasheet
      
      ;--------------------------------------------------------------------------------------------
      ; Datasheet window and sub windows will be closed
      ;--------------------------------------------------------------------------------------------
      
      If IsWindow(#Window_ViewDocument)
        
        CloseWindow(#Window_ViewDocument)
        
      EndIf
      
      ;----------------------------------------------------------------------------------------
      ; Remove the hoverable controls
      ;----------------------------------------------------------------------------------------
      
      RemoveHoverGadget(#Gadget_Datasheet_iLookupModel)
      
      RemoveHoverGadget(#Gadget_Datasheet_SaveMyStuff)
      
      RemoveHoverGadget(#Gadget_Datasheet_AddPicture)
      
      RemoveHoverGadget(#Gadget_Datasheet_Scanpicture)
      
      RemoveHoverGadget(#Gadget_Datasheet_AddDocument)
      
      RemoveHoverGadget(#Gadget_Datasheet_ScanDocument)
      
      RemoveHoverGadget(#Gadget_Datasheet_ViewDocument)
      
      RemoveHoverGadget(#Gadget_Datasheet_RelinkDocument)
      
      RemoveHoverGadget(#Gadget_Datasheet_ExitMyStuff)

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Refocus on main window and current record when data window is closed
  ;------------------------------------------------------------------------------------------------
  
  If WindowId.i <> #Window_Mystuff
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current line number so that we can refocus on it when the sub window is closed
    ;----------------------------------------------------------------------------------------------
    
    If Mystuffedit\CurrentLine <> #NothingSelected
      
      FocusLine.i = Mystuffedit\CurrentLine
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Close the form window if it is not the master window
    ;----------------------------------------------------------------------------------------------
    
    CloseWindow(WindowId.i)
    
    ;----------------------------------------------------------------------------------------------
    ; Tell the user what just happened
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings",  "Info", "Window" + " (" + Program\LastWindow + ") was closed", #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; Clear necessary variables
    ;----------------------------------------------------------------------------------------------
    
   ;Mystuffedit\CurrentLine   = #NothingSelected                                                    ; Make sure no line can be selected accidentally
   ;     
   ;Mystuffedit\CurrentRecord = #EmptyString                                                        ; Nullify the current record number to avoid mistakes
    
    Program\WindowMutex       = #False                                                              ; Make sure other windows can open now  
    
    Program\LastWindow        = #EmptyString                                                        ; Clear last used windows state

    ;----------------------------------------------------------------------------------------------
    ; Re-enable the main window and unhide it
    ;----------------------------------------------------------------------------------------------
    
    DisableWindow(#Window_Mystuff, #False)
    
    HideWindow(#Window_Mystuff, #False)
    
    SetActiveWindow(#Window_Mystuff)
    
    ;----------------------------------------------------------------------------------------------
    ; Make the main list the active gadget
    ;----------------------------------------------------------------------------------------------
    
    SetActiveGadget(#Gadget_Mystuff_Itemlist)
    
    SetGadgetState(#Gadget_Mystuff_Itemlist, FocusLine.i)
    
    PostEvent(#PB_Event_Gadget, #Window_Mystuff, #Gadget_Mystuff_Itemlist, #PB_EventType_Change)
    
    ;----------------------------------------------------------------------------------------------
    ; Clear the edit structure
    ;----------------------------------------------------------------------------------------------
    
    ClearStructure(@MyStuffEdit,  MyStuffEditData)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 50
; FirstLine = 37
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP