﻿;==============================================================================================================================================================================
; Convert an ISO format date to Australian and back
;==============================================================================================================================================================================

Procedure.s IsoDate(DateString.s, Direction.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Select Direction.s
      
    ;----------------------------------------------------------------------------------------------
    ; From Iso Date to normal (yyyy-mm-dd to dd/mm/yyyy)
    ;----------------------------------------------------------------------------------------------
  
    Case "NormalDate"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DateString.s <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Mid(DateString.s, 5, 1)  = "-" And Mid(DateString.s, 8, 1)  = "-"
          
          ;----------------------------------------------------------------------------------------
          ; From 2014-06-22 to 22/06/2014
          ;----------------------------------------------------------------------------------------
          
          FixedDate.s = StringField(DateString.s, 3, "-") + "/"     ; Day
          
          FixedDate.s + StringField(DateString.s, 2, "-") + "/"     ; Month
          
          FixedDate.s + StringField(DateString.s, 1, "-")           ; Year 
    
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "This is not a normal date format.", #PB_Compiler_Procedure)
          
          FixedDate.s = "#INVALID#"
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------

      Else
        
        FixedDate.s = #EmptyString
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; To Iso date from normal (dd/mm/yyyy to yyyy-mm-dd)
      ;--------------------------------------------------------------------------------------------

    Case "IsoDate"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DateString.s <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; From 22/06/2014 to 2014-06-22
        ;------------------------------------------------------------------------------------------
        
        If Mid(DateString.s, 3, 1)  = "/" And Mid(DateString.s, 6, 1)  = "/"

          ;----------------------------------------------------------------------------------------
          ; Conversion for SQLite for proper sorting
          ;----------------------------------------------------------------------------------------
          
          FixedDate.s = StringField(DateString.s, 3, "/") + "-"     ; Year
          
          FixedDate.s + StringField(DateString.s, 2, "/") + "-"     ; Month
          
          FixedDate.s + StringField(DateString.s, 1, "/")           ; Day
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
        
        Else
          
          SetInfoBarArea("Headings",  "Error",  "This is not an ISO date format.", #PB_Compiler_Procedure)
          
          FixedDate.s = "#INVALID#"
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
      
      Else
        
        FixedDate.s = #EmptyString
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  ProcedureReturn FixedDate.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 96
; FirstLine = 75
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP