﻿;==============================================================================================================================================================================
; Set the correct icons to the selected hoverable gadget
;==============================================================================================================================================================================

Procedure SetHoverIcons(Gadget.i, Image.i, State.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i x.i, y.i, w.i, h.i, Xmax.i, Ymax.i, Result.i
  
  Protected.l a.i, a_.i, max_x.i, max_y.i, ext.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If IsGadget(Gadget.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If IsImage(Image.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select State.s

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------

        Case "Hovered"
          
          ;----------------------------------------------------------------------------------------
          ; Extend on all sides by Glow\GlowRadius pixels if Glow\ExtendCanvas is #True
          ;----------------------------------------------------------------------------------------
          
          If Glow\ExtendCanvas
            
            ext.i = Glow\GlowRadius
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; Create output image
          ;----------------------------------------------------------------------------------------
          
          Result.i = CreateImage(#PB_Any, ImageWidth(Image.i) + ext.i << 1, ImageHeight(Image.i) + ext.i << 1, 32, #PB_Image_Transparent)
          
          If Result.i
            
            StartDrawing(ImageOutput(Result.i))
            
            DrawingMode(#PB_2DDrawing_AllChannels)     
            
            DrawImage(ImageID(Image.i), ext.i, ext.i)
            
            max_x.i = OutputWidth() - 1
            
            max_y.i = OutputHeight() - 1
            
            ; Dim arrays
            
            Protected Dim AlphaChannel.a(max_y.i, max_x.i)
            
            Protected Dim AlphaChannelTmp.a(max_y.i, max_x.i)
            
            ; build alpha channel array
            
            For y.i = 0 To max_y.i
              
              For x.i = 0 To max_x.i
                
                AlphaChannel(y.i, x.i) = Point(x.i, y.i) >> 24
                
              Next
              
            Next
            
            ; Blur alpha channel
            
            For y.i = 0 To max_y.i
              
              a_.i = AlphaChannel(y.i, 0)
              
              For x.i = 1 To Glow\GlowRadius
                
                a_.i + AlphaChannel(y.i, x.i)
                
              Next
              
              x.i = 0
              
              While x.i <= max_x.i
                
                a.i = a_.i >> 2
                
                If a.i > 255 
                  
                  a.i = 255
                  
                EndIf
                
                AlphaChannelTmp(y.i, x.i) = a.i
                
                If x.i >= Glow\GlowRadius
                  
                  a_.i - AlphaChannel(y.i, x.i - Glow\GlowRadius)
                  
                EndIf
                
                x.i + 1
                
                If x.i + Glow\GlowRadius <= max_x.i
                  
                  a_.i + AlphaChannel(y.i, x.i + Glow\GlowRadius)
                  
                EndIf
                
              Wend
              
            Next
            
            For x.i = 0 To max_x.i
              
              a_.i = AlphaChannelTmp(0, x.i)
              
              For y.i = 1 To Glow\GlowRadius
                
                a_.i + AlphaChannelTmp(y.i, x.i)
                
              Next
              
              y.i = 0
              
              While y.i <= max_y.i
                
                a.i = a_.i >> 2
                
                If a.i > 255
                  
                  a.i = 255
                  
                EndIf
                
                AlphaChannel(y.i, x.i) = a.i
                
                If y.i >= Glow\GlowRadius
                  
                  a_.i - AlphaChannelTmp(y.i - Glow\GlowRadius, x.i)
                  
                EndIf
                
                y.i + 1
                
                If y.i + Glow\GlowRadius <= max_y.i
                  
                  a_.i + AlphaChannelTmp(y.i + Glow\GlowRadius, x.i)
                  
                EndIf
                
              Wend
              
            Next
           
            ; Create blurred glow image
            
            Glow\GlowColour & $ffffff
            
            For y.i = 0 To max_y.i
              
              For x.i = 0 To max_x.i
                
                Plot(x.i, y.i, Glow\GlowColour | AlphaChannel(y.i, x.i) << 24)
                
              Next
              
            Next
            
            ; Merge with original
            
            DrawingMode(#PB_2DDrawing_AlphaBlend)
            
            DrawImage(ImageID(Image.i), ext.i, ext.i)
            
            StopDrawing()
            
          EndIf
            
          SetGadgetState(Gadget.i, ImageID(Result.i))
          
          FreeImage(Result.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Pressed"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          TempImage.i = CopyImage(Image.i, #PB_Any)
          
          If TempImage.i  <> #False  ;  It isn't 0
            
            ImgOutput = ImageOutput(TempImage.i)
            
            If ImgOutput <> #False
              
              DrawingOutput.i = StartDrawing(imgOutput)  ;  Crashes right here
              
              If DrawingOutput.i  <> #False
                
                Xmax.i = OutputWidth() - 1
                
                Ymax.i = OutputHeight() - 1
                
                For y.i = 0 To Ymax.i
                  
                  For x.i = 0 To Xmax.i
                    
                    Plot(x.i, y.i, Point(x.i, y.i) ! $FFFFFF)
                    
                  Next x.i
                  
                Next y.i
                
                StopDrawing()
                
                SetGadgetState(Gadget.i, ImageID(TempImage.i))
                
              EndIf
              
            Else
              
              Debug "Can output:              No"  
              
              Debug "Image constant:      " + Str(Image.i)
              
              Debug "Valid image:         " + Str(IsImage(Image))
              
              Debug "Temp image handle:   " + Str(TempImage.i)
              
              Debug "Valid temp image:    " + Str(IsImage(TempImage.i))
              
            EndIf
            
            FreeImage(TempImage.i)
            
          EndIf          
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Normal"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetState(Gadget.i, ImageID(Image.i))
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "The image for the gadget hovered over or pressed seems to be missing!!", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "This is not an initialised hoverable gadget.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 292
; FirstLine = 265
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP