﻿;==============================================================================================================================================================================
; Send messages and error reports to the fake status bar area
;==============================================================================================================================================================================

Procedure SetInfoBarArea(FieldName.s, FieldStatus.s = "##Error##", MessageContent.s = "0", ModuleName.s = #EmptyString)
  
  ;------------------------------------------------------------------------------------------------
  ; Select the name of the field to put our heading string
  ;------------------------------------------------------------------------------------------------
  
  Select FieldName.s
      
    ;----------------------------------------------------------------------------------------------
    ; Select the correct heading by the status field
    ;----------------------------------------------------------------------------------------------
      
    Case "Headings"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select FieldStatus.s
          
        Case "Welcome"
          
          MessageHeader.s = "Welcome"
          
          Colour.i        = $615E5F
          
        Case "Info"
          
          MessageHeader.s = "Information"
          
          Colour.i        = $DB3D24
          
        Case "Warn"
          
          MessageHeader.s = "Warning"
          
          Colour.i        = $7D1F82
          
        Case "Error"
          
          MessageHeader.s = "Error"
          
          Colour.i        = $0402FB
          
          WriteErrorLog(ModuleName.s, MessageContent.s)
          
        Case "Tool"
          
          MessageHeader.s = "Tooltip"
          
          Colour.i        = $FF0000
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; Send all the strings to the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Mystuff_Messages,   MessageHeader.s  + " "  + MessageContent.s)
      
      SetGadgetColor(#Gadget_Mystuff_Messages,  #PB_Gadget_FrontColor, Colour.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case "Current"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Mystuff_Current, "Record " + FormatNumber(MessageContent.s))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case "Total"

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Mystuff_Total, "Total " + GetCurrency(MessageContent.s))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case "Records"
      
      ;--------------------------------------------------------------------------------------------
      ; Figure out the correct spelling for the record field for singles or multiples
      ;--------------------------------------------------------------------------------------------
      
      If Val(MessageContent.s)      = 0
        
        RecordHeader.s = "Items"
        
      ElseIf Val(MessageContent.s) = 1
        
        RecordHeader.s = "Item"
        
      ElseIf Val(MessageContent.s) > = 2
        
        RecordHeader.s = "Items"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Set the record number details in the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      TrueCountOfItems.i = Val(MessageContent.s) + 1
      
      SetGadgetText(#Gadget_Mystuff_Records, FormatNumber(Str(TrueCountOfItems.i)) + " " + RecordHeader.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 48
; FirstLine = 98
; Folding = -
; EnableXP