﻿;==============================================================================================================================================================================
; Run an asynchronous clock in the window title bar
;==============================================================================================================================================================================

Procedure TitleBarClock(ObjectHandle.i, Message.i, EventNumber.i, TimePeriod.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select EventNumber.i

    ;----------------------------------------------------------------------------------------------
    ; User selected timer event number
    ;----------------------------------------------------------------------------------------------
    
    Case #TitleBarClockTimerEvent
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      LocalTimeDate.i = Date()
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CurrentDate.s = NameOfDay(DayOfWeek(LocalTimeDate.i))    + " "
      
      CurrentDate.s + Str(Day(LocalTimeDate.i))                + " "
      
      CurrentDate.s + NameOfMonth(Month(LocalTimeDate.i) - 1)  + " "
      
      CurrentDate.s + Str(Year(LocalTimeDate.i))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ; Fangbeast, you have a global for timezone offset, used here as offset had nowhere to come
      ; from, so nice & simple you were sooooo close :) 
      ; Regards, Baldrick :):)
      ; UtcTime   = AddDate(LocalTimeDate,  #PB_Date_Minute,Program\TimeOffset);Offset)
      ; utc time from local time
      
      HourVal.i   =   Hour(LocalTimeDate.i) 
      
      MinuteVal.i = Minute(LocalTimeDate.i)
      
      SecondVal.i = Second(LocalTimeDate.i)
      
      Hour12.i = HourVal.i % 12   ; Added to fix midnight 0 hour fault
      
      If Not Hour12.i            ;= 12 changed see above
        
        Hour12.i = 12             ; HourVal ; 0 will now display as 12 
        
        ;     Else  ; removed, see above
        
        ;       Hour12.i = HourVal.i % 12
        
      EndIf
      
      If HourVal.i > 11
        
        Suffix.s = " PM"
        
      Else
        
        Suffix.s = " AM"
        
      EndIf
      
      TimeString.s = "(12)  " + Str(Hour12.i) + ":" + RSet(Str(MinuteVal.i), 2, "0") + ":" + RSet(Str(SecondVal.i), 2, "0") + Suffix.s + ",  "
      
      TimeString.s + "(24)  " + FormatDate("%hh:%ii:%ss", LocalTimeDate.i)
      
      ;     TimeString.s + "(UTC)  " + FormatDate("%hh:%ii:%ss", UtcTime)          ; Show UTC time
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTitle(#Window_MyStuff, #Fish + #Basename + #Version + Program\CompileCounters + ", Date: " + CurrentDate.s + ", Time: " + TimeString.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 84
; FirstLine = 61
; Folding = -
; EnableXP