;================================================================================================================================================================================
; Count the number of records in an SQLite database
;================================================================================================================================================================================

Procedure.s CountRecords(TableField.s, TableName.s, ExtraArguments.s = #EmptyString)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s + "Select COUNT(" + TableField.s + ") AS totalrecs FROM " + TableName.s + #EmptyString  + ExtraArguments.s
  
  ;------------------------------------------------------------------------------------------------
  ; Get the count of the records in the database
  ;------------------------------------------------------------------------------------------------

  If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
    
    If FirstDatabaseRow(Program\DatabaseHandle)

      NumberOfRecords.s = GetDatabaseString(Program\DatabaseHandle, 0)
      
    EndIf

    FinishDatabaseQuery(Program\DatabaseHandle)
  
  Else
    
    NumberOfRecords.s = "0"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn NumberOfRecords.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure



; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 45
; FirstLine = 7
; Folding = -
; DisableDebugger
; HideErrorLog