﻿;==========================================================================================================================================================
; Delete all tables and data in mystuff database
;==========================================================================================================================================================

Procedure Deleteallmystuff()
  
  ;------------------------------------------------------------------------------------------------
  ; Ask the user if they really want to do this
  ;------------------------------------------------------------------------------------------------
  
  If MessageRequester("Mystuff database deletion", "The database is about to be emptied of ALL my stuff. Are you sure that you want to do this???", #PB_MessageRequester_YesNoCancel | #MB_ICONINFORMATION) = #PB_MessageRequester_Yes
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Program\DatabaseHandle <>  #DatabaseNotOpen
      
      ;--------------------------------------------------------------------------------------------
      ; Drop the Mystuff table
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseUpdate(Program\DatabaseHandle, "DROP TABLE Mystuff") <> #DatabaseUpdateFail
        
        ;------------------------------------------------------------------------------------------
        ; Empty the pictures table
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, "DROP TABLE Locations") <> #DatabaseUpdateFail
          
          ;----------------------------------------------------------------------------------------
          ; Empty the ingredients table
          ;----------------------------------------------------------------------------------------
          
          CloseDatabase(Program\DatabaseHandle)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          ClearGadgetItems(#Gadget_Mystuff_Locations)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          ClearGadgetItems(#Gadget_Mystuff_Itemlist)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          OpenSystemDatabase()
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          GetLocations()
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          NumberOfItems.i = CountGadgetItems(#Gadget_Mystuff_Itemlist)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If NumberOfItems.i = #NoItems
            
            SetInfoBarArea("Headings",  "Info",  "All Mystuff database tables have been emptied and you can start again fresh.", #PB_Compiler_Procedure)
            
            SetInfoBarArea("Current",   #EmptyString,         "?", #PB_Compiler_Procedure)
            
            SetInfoBarArea("Records",   #EmptyString,         "0", #PB_Compiler_Procedure)
            
          ElseIf NumberOfItems.i <> #NoItems
            
            SetGadgetState(#Gadget_Mystuff_Itemlist, #FirstItem)
            
            SetInfoBarArea("Headings",  "Welcome",  "Welcome to " + #Basename, #PB_Compiler_Procedure)
            
            SetInfoBarArea("Records",   #EmptyString,         Str(NumberOfItems.i), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Warn", "Could not drop the Locations table: " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; Tell the users what is going on
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", "Could not drop the old Mystuff table: " + DatabaseError(), #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "The Mystuff database isn't open, nothing to do.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Info", "Nothing to do as the user aborted the procedure.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 133
; FirstLine = 97
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP