﻿;==========================================================================================================================================================
; Export all my stuff to the temporary directory
;==========================================================================================================================================================

Procedure Exportmystuff()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected XMLFile.i, PictureOk.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ExportFileName.s = Program\BackupDirectory + "Mystuff XML export file.xml"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If GetExtensionPart(ExportFileName.s) <>  "xml"
    
    ExportFileName.s  + ".xml"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  XMLFile.i = CreateFile(#PB_Any, ExportFileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If XMLFile.i  <> #NoFileHandle
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    WriteStringN(XMLFile.i, "<?xml version=" + #DQUOTE$ + "1.0" + #DQUOTE$ + " encoding=" + #DQUOTE$ + "UTF-8" + #DQUOTE$ + "?>", #PB_UTF8)
    
    WriteStringN(XMLFile.i, #EmptyString, #PB_UTF8)
    
    WriteStringN(XMLFile.i, "<MyStuffData>", #PB_UTF8)
    
    WriteStringN(XMLFile.i, " <MyStuffList>", #PB_UTF8)
    
    ;----------------------------------------------------------------------------------------------
    ; Process the current table name
    ;----------------------------------------------------------------------------------------------
    
    DatabaseQuery.s = "SELECT * FROM Mystuff"
    
    If DatabaseQuery(Program\DatabaseHandle,  DatabaseQuery.s)  <> #DatabaseQueryFail
      
      While NextDatabaseRow(Program\DatabaseHandle)
        
        WriteStringN(XMLFile.i, "  <MyStyffInfo>", #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Nameofitem>"       + TextToXML(GetDatabaseString(Program\DatabaseHandle,  0)) + "</Nameofitem>",       #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Suppliername>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle,  1)) + "</Suppliername>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Manufacturer>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle,  2)) + "</Manufacturer>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Modelnumber>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle,  3)) + "</Modelnumber>",      #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Serialnumber>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle,  4)) + "</Serialnumber>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Productbarcode>"   + TextToXML(GetDatabaseString(Program\DatabaseHandle,  5)) + "</Productbarcode>",   #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Itemboughton>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle,  6)) + "</Itemboughton>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Workingitem>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle,  7)) + "</Workingitem>",      #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Whopaidforthis>"   + TextToXML(GetDatabaseString(Program\DatabaseHandle,  8)) + "</Whopaidforthis>",   #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Ownersname>"       + TextToXML(GetDatabaseString(Program\DatabaseHandle,  9)) + "</Ownersname>",       #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Locationname>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle, 10)) + "</Locationname>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Itemcondition>"    + TextToXML(GetDatabaseString(Program\DatabaseHandle, 11)) + "</Itemcondition>",    #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Categoryofitem>"   + TextToXML(GetDatabaseString(Program\DatabaseHandle, 12)) + "</Categoryofitem>",   #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Itemimportance>"   + TextToXML(GetDatabaseString(Program\DatabaseHandle, 13)) + "</Itemimportance>",   #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Itemloanedto>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle, 14)) + "</Itemloanedto>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Itemcomment>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle, 15)) + "</Itemcomment>",      #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Itempicture>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle, 16)) + "</Itempicture>",      #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Itemdocument>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle, 17)) + "</Itemdocument>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Costofitem>"       + TextToXML(GetDatabaseString(Program\DatabaseHandle, 18)) + "</Costofitem>",       #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Taxcomponent>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle, 19)) + "</Taxcomponent>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Deliveryfee>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle, 20)) + "</Deliveryfee>",      #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Othercost>"        + TextToXML(GetDatabaseString(Program\DatabaseHandle, 21)) + "</Othercost>",        #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Resalevalue>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle, 22)) + "</Resalevalue>",      #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Paidbymethod>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle, 23)) + "</Paidbymethod>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Warrantyperiod>"   + TextToXML(GetDatabaseString(Program\DatabaseHandle, 24)) + "</Warrantyperiod>",   #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Warrantyword>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle, 25)) + "</Warrantyword>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Stillactive>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle, 26)) + "</Stillactive>",      #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Extrapaid>"        + TextToXML(GetDatabaseString(Program\DatabaseHandle, 27)) + "</Extrapaid>",        #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Insureditem>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle, 28)) + "</Insureditem>",      #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Insuredfor>"       + TextToXML(GetDatabaseString(Program\DatabaseHandle, 29)) + "</Insuredfor>",       #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Insuredon>"        + TextToXML(GetDatabaseString(Program\DatabaseHandle, 30)) + "</Insuredon>",        #PB_UTF8)
       
        WriteStringN(XMLFile.i, "   <Insurername>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle, 31)) + "</Insurername>",      #PB_UTF8)
       
        WriteStringN(XMLFile.i, "   <Policynumber>"     + TextToXML(GetDatabaseString(Program\DatabaseHandle, 32)) + "</Policynumber>",     #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Contactnumber>"    + TextToXML(GetDatabaseString(Program\DatabaseHandle, 33)) + "</Contactnumber>",    #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Contactname>"      + TextToXML(GetDatabaseString(Program\DatabaseHandle, 34)) + "</Contactname>",      #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Contacdepartment>" + TextToXML(GetDatabaseString(Program\DatabaseHandle, 35)) + "</Contacdepartment>", #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Deleted>"          + TextToXML(GetDatabaseString(Program\DatabaseHandle, 36)) + "</Deleted>",          #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Favourite>"        + TextToXML(GetDatabaseString(Program\DatabaseHandle, 37)) + "</Favourite>",        #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Locked>"           + TextToXML(GetDatabaseString(Program\DatabaseHandle, 38)) + "</Locked>",           #PB_UTF8)
        
        WriteStringN(XMLFile.i, "   <Mystuffid>"        + TextToXML(GetDatabaseString(Program\DatabaseHandle, 39)) + "</Mystuffid>",        #PB_UTF8)
        
        WriteStringN(XMLFile.i, "  </MyStyffInfo>", #PB_UTF8)
        
      Wend
      
      FinishDatabaseQuery(Program\DatabaseHandle)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    WriteStringN(XMLFile.i, " </MyStuffList>", #PB_UTF8)
    
    WriteStringN(XMLFile.i, "</MyStuffData>", #PB_UTF8)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(XMLFile.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings",  "Info",  "Exported: "  + ExportFileName.s + " to disk.", #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "Could not create: "  + ExportFileName.s  + " on disk.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 170
; FirstLine = 149
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog