﻿;==========================================================================================================================================================
; Import an XML file of Mystuff entries
;==========================================================================================================================================================

Procedure ImportMyStuff()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ImportFile.s = OpenFileRequester("Import file from", Program\BackupDirectory, "XML file (*.xml)|*.xml", 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ImportFile.s <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; Did we get a file handle?
    ;----------------------------------------------------------------------------------------------
    
    ImportFileId.i = LoadXML(#PB_Any, ImportFile.s)
    
    ;----------------------------------------------------------------------------------------------
    ; Did we get a file handle?
    ;----------------------------------------------------------------------------------------------
    
    If ImportFileId.i <> #NoImportFileHandle
      
      ;--------------------------------------------------------------------------------------------
      ; Start the SQL command transactions to speed up additions to the database
      ;--------------------------------------------------------------------------------------------
      
      DatabaseUpdate(Program\DatabaseHandle, "Begin Transaction")
      
      ;--------------------------------------------------------------------------------------------
      ; Get the main node of the XML document
      ;--------------------------------------------------------------------------------------------
      
      *MainNode = MainXMLNode(ImportFileId.i)
      
      ;--------------------------------------------------------------------------------------------
      ; Parse the XML file
      ;--------------------------------------------------------------------------------------------
      
      ImportMystuffNode(*MainNode, CurrentSublevel.i)
      
      ;--------------------------------------------------------------------------------------------
      ; Commit All the SQL transactions to the database
      ;--------------------------------------------------------------------------------------------
      
      DatabaseUpdate(Program\DatabaseHandle, "Commit")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Info",  "The " + ImportFile.s  + " import file has been processed and imported", #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "The " + ImportFile.s  + " import file has not been processed or imported", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "Nothing to do, the user has cancelled the import process", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 86
; FirstLine = 50
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP