﻿;==========================================================================================================================================================
; Decode Mystuff node data
;==========================================================================================================================================================

Procedure ImportMystuffNode(*CurrentNode, CurrentSublevel.i)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If XMLNodeType(*CurrentNode) = #PB_XML_Normal
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    *ChildNode = ChildXMLNode(*CurrentNode)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    While *ChildNode <> 0
      
      ;--------------------------------------------------------------------------------------------
      ; Returns the tagname of the given XML node;
      ;--------------------------------------------------------------------------------------------
      
      NodeName.s =                         GetXMLNodeName(*ChildNode)
      
      ;--------------------------------------------------------------------------------------------
      ; Returns the text inside the given XML node.
      ;--------------------------------------------------------------------------------------------
      
      NodeText.s = Trim(RepQuote(XMLToText(GetXMLNodeText(*ChildNode))))
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      If NodeName.s <> "Mystuffid"                                          ;  A known last column
        
        OutPutString.s  + "'" + NodeText.s  + "',"
        
        TableString.s   +       NodeName.s  + ","
        
      Else
        
        OutPutString.s  = Left(OutPutString.s,  Len(OutPutString.s)   - 1)  ; : Debug OutPutString.s
        
        TableString.s   = Left(TableString.s,   Len(TableString.s)    - 1)  ; : Debug TableString.s
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "INSERT INTO Mystuff ("
        
        QueryString.s + TableString.s   + ") VALUES("
        
        QueryString.s + OutPutString.s  + ")"
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)  <> #DatabaseUpdateFail
          
          SetInfoBarArea("Headings",  "Info",  "The current Mystuff record has been imported successfully.", #PB_Compiler_Procedure)
          
        Else
          
          SetInfoBarArea("Headings",  "Info",  "The current Mystuff record has not been imported successfully:  " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      ImportMystuffNode(*ChildNode, CurrentSublevel.i + 1)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      *ChildNode = NextXMLNode(*ChildNode)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure 


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 112
; FirstLine = 76
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP