;==========================================================================================================================================================
; Prevent certain predefined characters being entered into string gadgets
;==========================================================================================================================================================

Procedure AllowOnly(Gadget.i, CharacterSet.i)

  ;------------------------------------------------------------------------------------------------
  ; Allow only the character set chosen to act on the passed string
  ;------------------------------------------------------------------------------------------------
  
  Select CharacterSet.i

    Case 1                                                                                          ; Which char set do I want?
  
    ValidChar.s = "()-0123456789"                                                                   ; Only characters that I want. Phone
    
  Case 2                                                                                            ; I only want currency chars
  
    ValidChar.s = "$0123456789."                                                                    ; Only characters that I want. Currency
    
  Case 3                                                                                            ; Only characters that I want. Numbers and decimal point
    
    ValidChar.s = "0123456789."                                                                     ; Only characters that I want. Currency
    
  Case 4                                                                                            ; I want letters and numbers
  
    ValidChar.s = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"                                            ; Numbers and uppercase characters

  Case 5                                                                                            ; I want letters and numbers
  
    ValidChar.s = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"                  ; Numbers and uppercase and lowercase characters
    
  Case 6                                                                                            ; I want letters and numbers

    ValidChar.s = "0123456789abcdefghijklmnopqrstuvwxyz"                                            ; Numbers and uppercase characters

  EndSelect                                                                                        ; End the conditional test

  ;------------------------------------------------------------------------------------------------
  ; Get the text to be checked from the passed gadget
  ;------------------------------------------------------------------------------------------------

  ValidationString.s = GetGadgetText(Gadget.i)                                                      ; Get the text to check

  ;------------------------------------------------------------------------------------------------
  ; Get the passed gadget's handle for the API routines
  ;------------------------------------------------------------------------------------------------

  GadgetHandle.i = GadgetID(Gadget.i)                                                               ; Get the gadget handle to target

  ;------------------------------------------------------------------------------------------------
  ; Now process the string, filter out what we don't need and refill the gadget
  ;------------------------------------------------------------------------------------------------

  For StartLoop.i = 1 To Len(ValidationString.s)                                                  ; Loop through the chars in the gadget

    KeepChar.i = FindString(ValidChar.s, Mid(ValidationString.s, StartLoop.i, 1), 1)               ; See if all characters in StringGadget are valid 

    If KeepChar.i = 0                                                                              ; See if we found a char to keep

      SendMessage_(GadgetHandle.i, #EM_GETSEL, @cPos, 0)                                           ; Get current caret position 

      NewString.s = RemoveString(ValidationString.s, Mid(ValidationString.s, StartLoop.i, 1), 1)   ; Remove invalid character 

      SetGadgetText(Gadget.i, NewString.s)                                                         ; Reset the displayed characters to keep

      SendMessage_(GadgetHandle.i, #EM_SETSEL, cPos.i - 1, cPos.i - 1)                             ; Set caret position to last position after setting newstring$ 

    EndIf                                                                                         ; End the conditional test

  Next                                                                                             ; Next iteration of the loop
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 11
; FirstLine = 39
; Folding = -
; DisableDebugger
; HideErrorLog