﻿;==============================================================================================================================================================================
; Wrap a string to a specified boundary
;==============================================================================================================================================================================

Procedure.s WordWrapString(SourceString.s, StringWidth.i, DelimiterList.s = "- " + Chr(9), NewLineString.s = #LF$)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i Position.i, FoundDelimiter.i, i
  
  Protected   ReturnedString.s = ""
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If StringWidth <= 0
    
    ProcedureReturn SourceString.s
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Position.i = Len(SourceString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  While Position.i > StringWidth
    
    For i = StringWidth To 1 Step -1
      
      FoundDelimiter.i = FindString(DelimiterList.s, Mid(SourceString.s, i, 1))
      
      If FoundDelimiter.i > 0
        
        Position.i = i
        
        Break
        
      EndIf
      
    Next
    
    If FoundDelimiter.i = 0
      
      For i = StringWidth + 1 To Position.i
        
        FoundDelimiter.i = FindString(DelimiterList.s, Mid(SourceString.s, i, 1))
        
        If FoundDelimiter.i > 0
          
          Position.i = i
          
          Break
          
        EndIf
        
      Next
      
    EndIf
    
    ReturnedString.s  + RTrim(Left(SourceString.s, Position.i)) + NewLineString.s
    
    SourceString.s    = LTrim(Mid(SourceString.s,  Position.i   + 1))
    
    Position.i        = Len(SourceString.s)
    
  Wend
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn ReturnedString.s + SourceString.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.41 LTS (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableXP