﻿;==========================================================================================================================================================
; Mystuff 'About' window
;==========================================================================================================================================================

Procedure Aboutmystuff()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\WindowMutex <> #True
    
    ;----------------------------------------------------------------------------------------------
    ; Attempt to open the module window
    ;----------------------------------------------------------------------------------------------
    
    If Window_Aboutmystuff()
      
      ;--------------------------------------------------------------------------------------------
      ; Prevent user input on the main window
      ;--------------------------------------------------------------------------------------------
      
      DisableWindow(#Window_Mystuff, #True)
      
      ;--------------------------------------------------------------------------------------------
      ; No other window may open
      ;--------------------------------------------------------------------------------------------
      
      Program\WindowMutex = #True
      
      ;--------------------------------------------------------------------------------------------
      ; Add this window's fast escape shortcut
      ;--------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_Aboutmystuff, #Keys_Aboutmystuff_Escape, #Shortcut_Aboutmystuff_escape)
      
      ;--------------------------------------------------------------------------------------------
      ; Setup the window tool tips
      ;--------------------------------------------------------------------------------------------
      
      ;SelectWindowToolTips(#Window_Aboutmystuff)
      
      ;--------------------------------------------------------------------------------------------
      ; Setup the dual message
      ;--------------------------------------------------------------------------------------------
      
      Message.s = "About " + #BaseName + #Version + Program\CompileCounters
      
      ;--------------------------------------------------------------------------------------------
      ; Display the window title message
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTitle(#Window_Aboutmystuff, Message.s)
      
      ;--------------------------------------------------------------------------------------------
      ; Setup the default note area font
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetFont(#Gadget_Aboutmystuff_Information, LoadFont(#Gadget_Aboutmystuff_Information, "Arial", 11, 0))
      
      ;--------------------------------------------------------------------------------------------
      ; Set wrapping to the notepad border
      ;--------------------------------------------------------------------------------------------
      
      SendMessage_(GadgetID(#Gadget_Aboutmystuff_Information), #EM_SETTARGETDEVICE, #Null, 0)
      
      ;--------------------------------------------------------------------------------------------
      ; Stream the RTF 'about' data into the note area from the data section
      ;--------------------------------------------------------------------------------------------
      
      CatchRTF(#Gadget_Aboutmystuff_Information, ?_MGB_AboutMystuff)
      
      ;--------------------------------------------------------------------------------------------
      ; Display status to the user
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "Could not open the about program window. Program error", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Display status to the user
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Info", "Another program window is still open, close that one first.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Display status to the user
  ;------------------------------------------------------------------------------------------------
  
EndProcedure



; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 46
; FirstLine = 35
; Folding = -
; EnableXP