﻿;==============================================================================================================================================================================
; Edit the current location and update the mystuff entries for that location; 
;==============================================================================================================================================================================

Procedure EditLocation()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Location\CurrentLine.i      = GetGadgetState(#Gadget_Mystuff_Locations)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Location\CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Location\Currentrecord.s     = GetGadgetItemText(#Gadget_Mystuff_Locations, Location\CurrentLine.i, #LocationRecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Location\Currentrecord.s  <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Location\Location.s = Trim(StringField(GetGadgetItemText(#Gadget_Mystuff_Locations, Location\CurrentLine.i, #LocationTitleColumn), 1, "("))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Location\Location.s <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Select Location\Location.s
            
          Case "All my stuff", "No titles", "No locations", "Deleted stuff", "Favourite stuff", "Locked stuff"  + 

            "-----------------------"
            
            SetInfoBarArea("Headings",  "Info", "You cannot edit inbuilt locations in the list, makes no sense.", #PB_Compiler_Procedure)
            
          Default
            
            ;--------------------------------------------------------------------------------------
            ; Check if another window isn't open first
            ;--------------------------------------------------------------------------------------
            
            If Program\WindowMutex <> #True
              
              ;------------------------------------------------------------------------------------
              ; Check to see if the Location window could be opened
              ;------------------------------------------------------------------------------------
              
              If Window_Location()  <> #NoWindowId
                
                ;----------------------------------------------------------------------------------
                ; If there are no other open windows, set the window open flag
                ;----------------------------------------------------------------------------------
                
                Program\WindowMutex = #True
                
                ;----------------------------------------------------------------------------------
                ; Add this window's fast escape shortcut
                ;----------------------------------------------------------------------------------
                
                AddKeyboardShortcut(#Window_Location, #Keys_Location_Escape,  #Shortcut_Location_Escape)
                
                AddKeyboardShortcut(#Window_Location, #Keys_Location_Save,    #Shortcut_Location_Save)
                
                AddKeyboardShortcut(#Window_Location, #Keys_Location_Exit,    #Shortcut_Location_Exit)
                
                ;----------------------------------------------------------------------------------
                ; Add the hoverable controls
                ;----------------------------------------------------------------------------------
                
                AddHoverGadget(GadgetID(#Gadget_Location_Save))
                
                AddHoverGadget(GadgetID(#Gadget_Location_Exit))
                
                ;----------------------------------------------------------------------------------
                ; These are your balloon tooltips used on the main form. All headings, balloon text and 
                ; icons are re-useable variables taken from the constants file.
                ;----------------------------------------------------------------------------------
                
                If Program\BalloonFontId
                  
                  BalloonToolTip(#Window_Location, #Gadget_Location_Save, Program\BalloonFontId, $FFFFFF, #Keystext_Location_Save,    #CRLF$ + GetShortCutText(#Keys_Location_Save) + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Location_Save, 30), GetIconHandle(#Image_Location_Save))
                  
                  BalloonToolTip(#Window_Location, #Gadget_Location_Exit, Program\BalloonFontId, $FFFFFF, #Keystext_Location_Exit,    #CRLF$ + GetShortCutText(#Keys_Location_Exit) + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Location_Exit, 30), GetIconHandle(#Image_Location_Exit))
                  
                Else
                  
                  MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
                  
                EndIf            
                
                ;----------------------------------------------------------------------------------
                ; Disable all input on the main window until this one is closed
                ;----------------------------------------------------------------------------------
                
                DisableWindow(#Window_Mystuff, #True)
                
                ;----------------------------------------------------------------------------------
                ; Hide the main window until we are finished with the data window
                ;----------------------------------------------------------------------------------
                
                HideWindow(#Window_Mystuff, #True)
                
                ;----------------------------------------------------------------------------------
                ; Add the window title for various procedures and visuals
                ;----------------------------------------------------------------------------------
                
                Program\LastWindow = "Edit Old Location"
                
                ;----------------------------------------------------------------------------------
                ; Load the user chosen icons to be selected for locations
                ;----------------------------------------------------------------------------------
                
                DirectoryId.i = ExamineDirectory(#PB_Any, Program\IconsDirectory, "*.ico")
                
                If DirectoryId.i
                  
                  Repeat
                    
                    TypeOfFile.i  = NextDirectoryEntry(DirectoryId.i) 
                    
                    IconName.s    = DirectoryEntryName(DirectoryId.i)
                    
                    If TypeOfFile.i = #True And IconName.s <> "." And IconName.s <> ".."
                      
                      If FileSize(Program\IconsDirectory  + IconName.s) <> #FileDoesNotExist
                        
                        IconHandle.i = LoadImage(#PB_Any, Program\IconsDirectory  + IconName.s)
                        
                        If IconHandle.i <>  #NoPictureLoaded
                          
                          AddGadgetItem(#Gadget_Location_Locationicon, #AtTheEndOfTheList, IconName.s, ImageID(IconHandle.i))
                          
                        Else
                          
                          AddGadgetItem(#Gadget_Location_Locationicon, #AtTheEndOfTheList, IconName.s, ImageID(#MenuBarIcon_Mystuff_Blank))
                          
                          SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
                          
                        EndIf
                        
                      Else
                        
                        AddGadgetItem(#Gadget_Location_Locationicon, #AtTheEndOfTheList, IconName.s, ImageID(#MenuBarIcon_Mystuff_Blank))
                        
                        SetInfoBarArea("Headings", "Error", "Icon file does not exist or is damaged.", #PB_Compiler_Procedure)
                        
                      EndIf
                      
                    EndIf 
                    
                  Until TypeOfFile.i = #False
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                DatabaseQuery.s = "SELECT Location, Iconname FROM Locations "
                
                DatabaseQuery.s + "WHERE Locationid = '" + Location\Currentrecord.s  + "'"
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
                  
                  While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
                    
                    Locationname.s  = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
                    
                    Iconfilename.s  = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1))
                    
                  Wend
                  
                  FinishDatabaseQuery(Program\DatabaseHandle)
                  
                Else
                  
                  SetInfoBarArea("Headings",  "Warn", "Database query failed or returned no data: " +  DatabaseError(), #PB_Compiler_Procedure)
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                SetGadgetText(#Gadget_Location_Location,      Locationname.s)
                
                SetGadgetText(#Gadget_Location_Locationicon,  Iconfilename.s)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                NextRecordString.s  = " - Record: " + Location\Currentrecord.s
                
                ;----------------------------------------------------------------------------------
                ; Add a generic message for info bars and title areas
                ;----------------------------------------------------------------------------------
                
                Message.s = "Add new location"
                
                ;----------------------------------------------------------------------------------
                ; Set the window title bar with the record number and message
                ;----------------------------------------------------------------------------------
                
                SetWindowTitle(#Window_Location, Message.s + NextRecordString.s)
                
                ;----------------------------------------------------------------------------------
                ; Make sure this window is active for input
                ;----------------------------------------------------------------------------------
                
                SetActiveWindow(#Window_Location)
                
                ;----------------------------------------------------------------------------------
                ; Make sure the itemname field is ready for input
                ;----------------------------------------------------------------------------------
                
                SetActiveGadget(#Gadget_Location_Location)
                
                ;----------------------------------------------------------------------------------
                ; Add the message to the main window fake status area
                ;----------------------------------------------------------------------------------
                
                SetInfoBarArea("Headings",  "Info",  Message.s + NextRecordString.s, #PB_Compiler_Procedure)
                
                ;----------------------------------------------------------------------------------
                ; Go here if we could not open this data sheet window
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings",  "Warn",  "Could not open the "  + Program\LastWindow  + " window", #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; Go here if there is another program window open. Programmer error
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings",  "Error",  Program\LastWindow + " is still open bozo, close that one first", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; Nothing more to do folks
            ;--------------------------------------------------------------------------------------
            
        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error", "There was no location name found on that line to edit", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error", "There is no current location selected to edit", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error", "There is no current line selected by the user.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 191
; FirstLine = 268
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP