﻿;==========================================================================================================================================
; Export current locations to a text file on disk
;==========================================================================================================================================

Procedure ExportLocations()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = "SELECT Location, Iconname "
  
  DatabaseQuery.s + "FROM Locations "
  
  DatabaseQuery.s + "ORDER BY Location"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ExportLocation.i = CreateFile(#PB_Any, Program\TemporaryDirectory + "MyStuff_Locations.txt")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If ExportLocation.i <> #NoFileHandle
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Info", "Created the locations export file on disk.", #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
        
        WriteString(Program\DatabaseHandle,   KillQuote(GetDatabaseString(Program\DatabaseHandle, 0) + ","))
        
        WriteStringN(Program\DatabaseHandle,  KillQuote(GetDatabaseString(Program\DatabaseHandle, 1)))
        
      Wend
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FinishDatabaseQuery(Program\DatabaseHandle)

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CloseFile(ExportLocation.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error", "Could not create the locations export file on disk.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error", "Could not find any locations in the database: " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 48
; FirstLine = 52
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP