﻿;==========================================================================================================================================
; Export current locations to a text file on disk
;==========================================================================================================================================

Procedure ImportLocations()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Location.s, Locationstring.s, Importlocation.i
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon. That is standard categories + two others
  ;------------------------------------------------------------------------------------------------

  ImportLocation.i = ReadFile(#PB_Any, Program\TemporaryDirectory + "MyStuff_Locations.txt")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ImportLocation.i <> #NoFileHandle
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings",  "Info", "Opened the locations export file from disk.", #PB_Compiler_Procedure)
    
    ClearGadgetItems(#Gadget_Mystuff_Locations)
    
    GetLocations()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While Eof(ImportLocation.i) = #NotEndOfFile
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      LocationString.s = ReadString(ImportLocation.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If LocationString.s  <>  #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Location.s  = StringField(LocationString.s, 1, ",")
        
        Iconname.s  = StringField(LocationString.s, 2, ",")
        
        ;------------------------------------------------------------------------------------------
        ; Load the user chosen icons to be selected for locations
        ;------------------------------------------------------------------------------------------
        
        IconHandle.i = LoadImage(#PB_Any, Program\IconsDirectory  + Iconname.s)
        
        If IconHandle.i <>  #NoPictureLoaded
          
          AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, Location.s, ImageID(IconHandle.i))
          
        Else
          
          AddGadgetItem(#Gadget_Location_Locationicon, #AtTheEndOfTheList, IconName.s, ImageID(#MenuBarIcon_Mystuff_Blank))
          
          SetInfoBarArea("Headings", "Error", "Could load the location as the icon file is missing.", #PB_Compiler_Procedure)
          
        EndIf

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        UpdateLocationItemCount(Location.s)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Sortlocations()
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(ImportLocation.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error", "Could not create the locations export file on disk.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 49
; FirstLine = 49
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP