﻿;==========================================================================================================================================================
; Save the new or changed location information
;==========================================================================================================================================================

Procedure SaveLocation()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Locationname.s  = RepQuote(GetGadgetText(#Gadget_Location_Location))
  
  Iconname.s      = RepQuote(GetGadgetText(#Gadget_Location_Locationicon))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select Program\LastWindow

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    Case "Add New Location"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Locationname.s  <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Len(Locationname.s) > = 6
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Locationname.s = UCase(Left(Locationname.s, 1)) + Mid(Locationname.s, 2, Len(Locationname.s) - 1)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          DatabaseUpdate.s  = "INSERT INTO Locations("
          
          DatabaseUpdate.s  + "Location, Iconname, Itemcount) "
          
          DatabaseUpdate.s  + "VALUES('"
          
          DatabaseUpdate.s  + Locationname.s  + "', "
          
          DatabaseUpdate.s  + Iconname.s      + "', "

          DatabaseUpdate.s  + "'0')"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            Newrecordnumber.s = DatabaseLastInsertRowId()
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If Newrecordnumber.s <> #EmptyString
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              ImageNumber.i = LoadImage(#PB_Any, Program\IconsDirectory  + Iconname.s)
              
              If ImageNumber.i
                
                AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, KillQuote(Locationname.s)  + #LF$  + Iconname.s  + #LF$ + "0" + #LF$  + Newrecordnumber.s, ImageID(ImageNumber.i))
                
              Else
                
                AddGadgetItem(#Gadget_Mystuff_Locations, #AtTheEndOfTheList, KillQuote(Locationname.s)  + #LF$  + Iconname.s  + #LF$ + "0" + #LF$  + Newrecordnumber.s, ImageID(#MenuBarIcon_Mystuff_Blank))
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings",  "Info", "Saved new location:  " + KillQuote(Locationname.s) + " into the database", #PB_Compiler_Procedure)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings",  "Error", "Could not get a new record number for the new location.", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Error", "Could not save the new location into the database: " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Warn", "The new location is too short. 6 characters is not useful.", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Warn", "No new location saved, user aborted the process.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case "Edit Old Location"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Locationname.s <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DatabaseUpdate.s  = "UPDATE Locations "
        
        DatabaseUpdate.s  + "SET Location = '"      + Locationname.s    + "', "
        
        DatabaseUpdate.s  + "    Iconname = '"      + Iconname.s        + "' "
        
        DatabaseUpdate.s  + "WHERE Locationid = '"  + Location\Currentrecord.s    + "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetItemText(#Gadget_Mystuff_Locations, Location\Currentline,  KillQuote(Locationname.s),  #LocationTitleColumn)
          
          SetGadgetItemText(#Gadget_Mystuff_Locations, Location\Currentline,  KillQuote(Iconname.s),      #LocationIconColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings",  "Info", "The edited location was saved to Locations.", #PB_Compiler_Procedure)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          DatabaseUpdate.s  = "UPDATE Mystuff "
          
          DatabaseUpdate.s  + "SET Location = '"    +          Locationname.s       + "' "
          
          DatabaseUpdate.s  + "WHERE Location = '"  + RepQuote(Location\Location.s) + "'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
            
            SetInfoBarArea("Headings",  "Info", "The changed location was updated in Mystuff.", #PB_Compiler_Procedure)
            
          Else
            
            SetInfoBarArea("Headings",  "Error", "The changed location could not be updated in Mystuff: " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error", "The edited location could not be saved to Locations: " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Warn", "The location string is empty so there is nothing to save.",  #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  UpdateLocationItemCount(Locationname.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Sortlocations()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CloseMyWindow(#Window_Location)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 116
; FirstLine = 113
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog