﻿;==============================================================================================================================================================================
; Sort ListIconGadget as you need it. Based on Reg Venaglia's routine.
;==============================================================================================================================================================================

Procedure Sortlocations()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected IconHandle.i, NumberOfItems.i, LoopCounter.i

  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_Mystuff_Locations)
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon. That is standard categories + two others
  ;------------------------------------------------------------------------------------------------
  
  If NumberOfItems.i > 9
    
    ;----------------------------------------------------------------------------------------------
    ; Get number items in ListIcon
    ;----------------------------------------------------------------------------------------------
    
    NewList Location.LocationData()
    
    ;----------------------------------------------------------------------------------------------
    ; Place each item text into the list. Must start at Zero
    ;----------------------------------------------------------------------------------------------
    
    For LoopCounter.i = 0 To NumberOfItems.i - 1
      
      AddElement(Location())
      
      Location()\Location   = GetGadgetItemText(#Gadget_Mystuff_Locations, LoopCounter.i, #LocationTitleColumn)
      
      Location()\Iconname   = GetGadgetItemText(#Gadget_Mystuff_Locations, LoopCounter.i, #LocationIconColumn)
      
      Location()\Hasitems   = GetGadgetItemText(#Gadget_Mystuff_Locations, LoopCounter.i, #LocationItemsColumn)
      
      Location()\Locationid = GetGadgetItemText(#Gadget_Mystuff_Locations, LoopCounter.i, #LocationRecordColumn)
      
    Next LoopCounter.i
    
    ;----------------------------------------------------------------------------------------------
    ; Sort the Array in ascending order
    ;----------------------------------------------------------------------------------------------
    
    SortStructuredList(Location(), #PB_Sort_Ascending, OffsetOf(LocationData\Location), #PB_String, 9, ListIndex(Location()))
    
    ;----------------------------------------------------------------------------------------------
    ; Now replace ListIcon Items from the sorted Array
    ;----------------------------------------------------------------------------------------------
    
    ForEach Location()
      
      SetGadgetItemText(#Gadget_Mystuff_Locations, ListIndex(Location()), Location()\Location,    #LocationTitleColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Locations, ListIndex(Location()), Location()\Iconname,    #LocationIconColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Locations, ListIndex(Location()), Location()\Hasitems,    #LocationItemsColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Locations, ListIndex(Location()), Location()\Locationid,  #LocationRecordColumn)
      
      If Location()\Iconname  <>  #EmptyString
        
        If FileSize(Program\IconsDirectory  + Location()\Iconname) <> #NoPictureFound
          
          IconHandle.i = LoadImage(#PB_Any, Program\IconsDirectory  + Location()\Iconname)
          
          If IconHandle.i <> #NoPictureLoaded
            
            SetGadgetItemImage(#Gadget_Mystuff_Locations, ListIndex(Location()), ImageID(IconHandle.i))
            
          Else
            
            SetGadgetItemImage(#Gadget_Mystuff_Locations, ListIndex(Location()), ImageID(#MenuBarIcon_Mystuff_Blank))
          
          EndIf
          
        EndIf
        
      EndIf
      
    Next Location()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearList(Location())
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 70
; FirstLine = 67
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP