﻿;==========================================================================================================================================================
; Add new stuff to my home inventory list
;==========================================================================================================================================================

Procedure AddNewStuff()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if another window isn't open first
  ;------------------------------------------------------------------------------------------------
  
  If Program\WindowMutex <> #True
    
    ;----------------------------------------------------------------------------------------------
    ; Check to see if the datasheet window could be opened
    ;----------------------------------------------------------------------------------------------
    
    If Window_Datasheet()  <> #NoWindowId
      
      ;--------------------------------------------------------------------------------------------
      ; If there are no other open windows, set the window open flag
      ;--------------------------------------------------------------------------------------------
      
      Program\WindowMutex = #True
      
      ;--------------------------------------------------------------------------------------------
      ; Hack to include Kenmo's rating gadget instead of the string gadget
      ;--------------------------------------------------------------------------------------------
      
      ; StringGadget(#Gadget_Datasheet_Importance,160,339,110,25,"",#PB_String_ReadOnly|#PB_String_BorderLess)
      
      OpenGadgetList(#Gadget_Datasheet_cDetails)
      
      RatingGadget(#Gadget_Datasheet_Importance, 160,339,110,25)
      
      RatingGadget_SetMaximum(#Gadget_Datasheet_Importance, 6)  
      
      CloseGadgetList()
      
      ;--------------------------------------------------------------------------------------------
      ; Add this window's fast escape shortcut
      ;--------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Escape,              #Shortcut_Datasheet_Escape)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Savemystuff,         #Shortcut_Datasheet_Savemystuff)
      
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_LookupModel,         #Shortcut_Datasheet_Lookupmodel)
      
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Menu_Addpicture,     #Shortcut_Datasheet_Menu_Addpicture)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Menu_Clearpicture,   #Shortcut_Datasheet_Menu_Clearpicture)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Menu_DeletePicture,  #Shortcut_Datasheet_Menu_DeletePicture)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Menu_ScanPicture,    #Shortcut_Datasheet_Menu_ScanPicture)
      
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_AddPicture,          #Shortcut_Datasheet_AddPicture)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_ScanPicture,         #Shortcut_Datasheet_ScanPicture)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_AddDocument,         #Shortcut_Datasheet_AddDocument)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_ScanDocument,        #Shortcut_Datasheet_ScanDocument)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_ViewDocument,        #Shortcut_Datasheet_ViewDocument)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_RelinkDocument,      #Shortcut_Datasheet_RelinkDocument)
      
      AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_ExitMyStuff,         #Shortcut_Datasheet_ExitMyStuff)

      ;--------------------------------------------------------------------------------------------
      ; Add the hoverable controls
      ;--------------------------------------------------------------------------------------------
      
      AddHoverGadget(GadgetID(#Gadget_Datasheet_iLookupModel))
      
      AddHoverGadget(GadgetID(#Gadget_Datasheet_SaveMyStuff))
      
      AddHoverGadget(GadgetID(#Gadget_Datasheet_AddPicture))
      
      AddHoverGadget(GadgetID(#Gadget_Datasheet_Scanpicture))
      
      AddHoverGadget(GadgetID(#Gadget_Datasheet_AddDocument))
      
      AddHoverGadget(GadgetID(#Gadget_Datasheet_ScanDocument))
      
      AddHoverGadget(GadgetID(#Gadget_Datasheet_ViewDocument))
      
      AddHoverGadget(GadgetID(#Gadget_Datasheet_RelinkDocument))
      
      AddHoverGadget(GadgetID(#Gadget_Datasheet_ExitMyStuff))
      
      ;--------------------------------------------------------------------------------------------
      ; These are your balloon tooltips used on the main form. All headings, balloon text and 
      ; icons are re-useable variables taken from the constants file.
      ;--------------------------------------------------------------------------------------------
      
      If Program\BalloonFontId
        
        BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Savemystuff,    Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Savemystuff,    #CRLF$ + GetShortCutText(#Keys_Datasheet_Savemystuff)     + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Savemystuff,     30),  GetIconHandle(#Image_Datasheet_Savemystuff))
        
        BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Addpicture,     Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Addpicture,     #CRLF$ + GetShortCutText(#Keys_Datasheet_Addpicture)      + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Addpicture,      30),  GetIconHandle(#Image_Datasheet_Addpicture))
        
        BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Scanpicture,    Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Scanpicture,    #CRLF$ + GetShortCutText(#Keys_Datasheet_Scanpicture)     + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Scanpicture,     30),  GetIconHandle(#Image_Datasheet_Scanpicture))
        
        BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Scandocument,   Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Scandocument,   #CRLF$ + GetShortCutText(#Keys_Datasheet_Scandocument)    + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Scandocument,    30),  GetIconHandle(#Image_Datasheet_Scandocument))
        
        BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Adddocument,    Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Adddocument,    #CRLF$ + GetShortCutText(#Keys_Datasheet_Adddocument)     + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Adddocument,     30),  GetIconHandle(#Image_Datasheet_Adddocument))
        
        BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Viewdocument,   Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Viewdocument,   #CRLF$ + GetShortCutText(#Keys_Datasheet_Viewdocument)    + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Viewdocument,    30),  GetIconHandle(#Image_Datasheet_Viewdocument))
        
        BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Relinkdocument, Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Relinkdocument, #CRLF$ + GetShortCutText(#Keys_Datasheet_Relinkdocument)  + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Relinkdocument,  30),  GetIconHandle(#Image_Datasheet_Relinkdocument))
        
        BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Exitmystuff,    Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Exitmystuff,    #CRLF$ + GetShortCutText(#Keys_Datasheet_Exitmystuff)     + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Exitmystuff,     30),  GetIconHandle(#Image_Datasheet_Exitmystuff))
        
      Else
        
        MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
        
      EndIf

      ;--------------------------------------------------------------------------------------------
      ; Disable all input on the main window until this one is closed
      ;--------------------------------------------------------------------------------------------
      
      DisableWindow(#Window_Mystuff, #True)
      
      ;--------------------------------------------------------------------------------------------
      ; Hide the main window until we are finished with the data window
      ;--------------------------------------------------------------------------------------------
      
      HideWindow(#Window_Mystuff, #True)
      
      ;--------------------------------------------------------------------------------------------
      ; Make sure the picture save string is empty at the start
      ;--------------------------------------------------------------------------------------------
      
      Mystuffedit\Newpicturetosave = #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; Add the window title for various procedures and visuals
      ;--------------------------------------------------------------------------------------------

      Program\LastWindow = "Add New Stuff"
      
      ;--------------------------------------------------------------------------------------------
      ; Fill the various combobox fields with data from the database
      ;--------------------------------------------------------------------------------------------
      
      FillCombo(#Gadget_Datasheet_Supplier,       "SELECT DISTINCT Supplier FROM Mystuff ORDER BY Supplier")
      
      FillCombo(#Gadget_Datasheet_Manufacturer,   "SELECT DISTINCT Manufacturer FROM Mystuff ORDER BY Manufacturer")
      
      FillCombo(#Gadget_Datasheet_Working,        "SELECT DISTINCT Working FROM Mystuff ORDER BY Working")
      
      FillCombo(#Gadget_Datasheet_WhoPaid,        "SELECT DISTINCT Whopaid FROM Mystuff ORDER BY Whopaid")
      
      FillCombo(#Gadget_Datasheet_OwnerName,      "SELECT DISTINCT Ownername FROM Mystuff ORDER BY Ownername")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      DatabaseQuery.s = "SELECT Location, Filename "
      
      DatabaseQuery.s + "FROM Locations "
      
      DatabaseQuery.s + "ORDER BY Location"
      
      If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle)
          
          LocationString.s = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
          
          UsericonString.s = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1))
          
          If LocationString.s <> #EmptyString
            
            UserIconHandle.i = LoadImage(#PB_Any, Program\IconsDirectory  + UsericonString.s)
            
            If UserIconHandle.i <>  #NoPictureLoaded
              
              AddGadgetItem(#Gadget_Datasheet_Location, #AtTheEndOfTheList, LocationString.s, ImageID(UserIconHandle.i))
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
              
            EndIf
            
          EndIf
          
        Wend
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FillCombo(#Gadget_Datasheet_Condition,      "SELECT DISTINCT Condition FROM Mystuff ORDER BY Condition")
      
      FillCombo(#Gadget_Datasheet_Category,       "SELECT DISTINCT Category FROM Mystuff ORDER BY Category")
      
      FillCombo(#Gadget_Datasheet_Loanedto,       "SELECT DISTINCT Loanedto FROM Mystuff ORDER BY Loanedto")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
     ;FillCombo(#Gadget_Datasheet_PaidBy,         "SELECT DISTINCT Paidby FROM Mystuff ORDER BY Paidby")
      
      AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Unknown",        ImageID(#Image_Datasheet_Unknown))
      
      AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Bank transfer",  ImageID(#Image_Datasheet_Banktransfer))
      
      AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Cash",           ImageID(#Image_Datasheet_Cash))
      
      AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Cheque",         ImageID(#Image_Datasheet_Cheque))
      
      AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Eftpos",         ImageID(#Image_Datasheet_Eftpos))
      
      AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Mastercard",     ImageID(#Image_Datasheet_Mastercard))
      
      AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Paypal",         ImageID(#Image_Datasheet_Paypal))
      
      AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Visa",           ImageID(#Image_Datasheet_Visa))

      SetGadgetState(#Gadget_Datasheet_PaidBy, #FirstItem)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FillCombo(#Gadget_Datasheet_WarrantyWord,   "SELECT DISTINCT Warrantyword FROM Mystuff ORDER BY Warrantyword")
      
      FillCombo(#Gadget_Datasheet_WarrantyActive, "SELECT DISTINCT Warrantyactive FROM Mystuff ORDER BY Warrantyactive")
      
      FillCombo(#Gadget_Datasheet_Insured,        "SELECT DISTINCT Insured FROM Mystuff ORDER BY Insured")
      
      FillCombo(#Gadget_Datasheet_InsurerName,    "SELECT DISTINCT Insurername FROM Mystuff ORDER BY Insurername")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetState(#Gadget_Datasheet_BoughtOn, #False)
      
      SetGadgetState(#Gadget_Datasheet_InsuredOn, #False)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
      CleanDirectory(Program\TemporaryDirectory)
      
      ;--------------------------------------------------------------------------------------------
      ; Setup the next possible record number variable
      ;--------------------------------------------------------------------------------------------
      
      NextRecord.s = Str(Val(LastRecord("Mystuffid", "Mystuff")) + 1)
      
      ;--------------------------------------------------------------------------------------------
      ; Setup the nextrecord generic string message
      ;--------------------------------------------------------------------------------------------
      
      NextRecordString.s  = "   --   Record number: " + NextRecord.s + "?"
      
      ;--------------------------------------------------------------------------------------------
      ; Add a generic message for info bars and title areas
      ;--------------------------------------------------------------------------------------------
      
      Message.s = "Add new stuff to your inventory"
      
      ;--------------------------------------------------------------------------------------------
      ; Set the window title bar with the record number and message
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTitle(#Window_Datasheet, Message.s + NextRecordString.s)
      
      ;--------------------------------------------------------------------------------------------
      ; Make sure this window is active for input
      ;--------------------------------------------------------------------------------------------
      
      SetActiveWindow(#Window_Datasheet)
      
      ;--------------------------------------------------------------------------------------------
      ; Make sure the itemname field is ready for input
      ;--------------------------------------------------------------------------------------------

      SetActiveGadget(#Gadget_Datasheet_ItemName)
      
      ;--------------------------------------------------------------------------------------------
      ; Add the generic message to this windows fake status area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_Datasheet_sStatusbar,  Message.s)
      
      ;--------------------------------------------------------------------------------------------
      ; Add the message to the main window fake status area
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Info",  Message.s + NextRecordString.s, #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; Go here if we could not open this data sheet window
      ;--------------------------------------------------------------------------------------------

    Else
      
      SetInfoBarArea("Headings",  "Warn",  "Could not open the "  + Program\LastWindow  + " window", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Go here if there is another program window open. Programmer error
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  Program\LastWindow + " is still open bozo, close that one first", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Nothing more to do folks
  ;------------------------------------------------------------------------------------------------
  
EndProcedure



; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 186
; FirstLine = 271
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP