﻿;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Procedure.l AquireDocument(wPixTypes.l, dResolution.d, reset.w)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Static PDFStarted.i
  Static PageNumber.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Define hDib.l
  Define sTempFileName.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ; Debug "Current page number: " + Str(PageNumber.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If reset
    
    PDFStarted.i = #False
    
    PageNumber.i = #False
    
    ProcedureReturn #True
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If TWAIN_State() <> #TWAIN_SOURCE_OPEN
    
    TWAIN_OpenDefaultSource()
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Not TWAIN_GetHideUI()
    
    TWAIN_SetHideUI(#True)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  TWAIN_SetCurrentResolution(dResolution)
  
  ;------------------------------------------------------------------------------------------------
  ; Colour should be 4 not 3 this is a hack fix
  ;------------------------------------------------------------------------------------------------
  
  If wPixTypes = 3
    
    wPixtypes = 4
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  hDib = TWAIN_AcquireNative(0, wPixTypes)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If hDib
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    PageNumber + 1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    sTempFileName.s = Program\TemporaryDirectory + RSet(Str(PageNumber), 3, "0") + ".jpg"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    hkTWAIN_WriteNativeToJPG(hdib, sTempFileName.s, 300)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    TWAIN_FreeNative(hDib)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Not PDFStarted.i
      
      pdf_Create("P", "in", #PDF_PAGE_FORMAT_A4)
      
      pdf_SetTitle("Scan")
      
      PDFStarted.i = #True
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    pdf_AddPage("P", #PDF_PAGE_FORMAT_A4)
    
    pdf_Image(sTempFileName.s, 0, 0, 8.5, 0)
    
    ;----------------------------------------------------------------------------------------------
    ; Delete temporary scan image
    ;----------------------------------------------------------------------------------------------
    
    DeleteFile(sTempFileName.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_ScanDocument_bScannext, "Scan Page #" + Str(PageNumber.i + 1))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ProcedureReturn #True
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn #False
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 144
; FirstLine = 72
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog