﻿;==============================================================================================================================================================================
; Handle all list display jobs from add, edit, list, import modes etc
;==============================================================================================================================================================================

Procedure DisplayMystuffString(LineNumber.i, DisplayMode.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select DisplayMode.s

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    Case  "Add New Stuff"
      
      ;--------------------------------------------------------------------------------------------
      ; Add recipes to the list
      ;--------------------------------------------------------------------------------------------
      
      ListString.s = Mystuff\Itemname       + #LF$ + 

      Mystuff\Loanedto                      + #LF$ + 

      Mystuff\Location                      + #LF$ + 

      Mystuff\Category                      + #LF$ + 

      GetCurrency(Mystuff\Cost)             + #LF$ + 

      Mystuff\Deleted                       + #LF$ + 

      Mystuff\Favourite                     + #LF$ + 

      Mystuff\Locked                        + #LF$ + 

      Mystuff\Mystuffid
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_Mystuff_Itemlist, #AtTheEndOfTheList,  KillQuote(ListString.s))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------

      SetGadgetItemColor(#Gadget_Mystuff_Itemlist, #PB_All, #PB_Gadget_FrontColor, $0000FF, #LoanedtoColumn)
      
      SetGadgetItemColor(#Gadget_Mystuff_Itemlist, #PB_All, #PB_Gadget_FrontColor, $008000, #LocationColumn)
      
      SetGadgetItemColor(#Gadget_Mystuff_Itemlist, #PB_All, #PB_Gadget_FrontColor, $800000, #CategoryColumn)
      
      SetGadgetItemColor(#Gadget_Mystuff_Itemlist, #PB_All, #PB_Gadget_FrontColor, $800080, #CostColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Records", #EmptyString, Str(LineNumber.i), #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ListString.s = #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; Update columns in the list for an edited record
      ;--------------------------------------------------------------------------------------------
      
    Case  "Edit Old Stuff"
      
      ;--------------------------------------------------------------------------------------------
      ; Update the details in the list for the selected record
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetItemText(#Gadget_Mystuff_Itemlist, LineNumber.i,   KillQuote(Mystuff\Itemname),        #NameofitemColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Itemlist, LineNumber.i,   KillQuote(Mystuff\Loanedto),        #LoanedtoColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Itemlist, LineNumber.i,   KillQuote(Mystuff\Location),        #LocationColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Itemlist, LineNumber.i,   KillQuote(Mystuff\Category),        #CategoryColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Itemlist, LineNumber.i, GetCurrency(Mystuff\Cost),            #CostColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Itemlist, LineNumber.i,             Mystuff\Deleted,          #DeletedColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Itemlist, LineNumber.i,             Mystuff\Favourite,        #FavouriteColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Itemlist, LineNumber.i,             Mystuff\Locked,           #LockedColumn)
      
      SetGadgetItemText(#Gadget_Mystuff_Itemlist, LineNumber.i,             Mystuff\Mystuffid,        #RecordColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Toggle individual rows to different colours
  ;------------------------------------------------------------------------------------------------
  
  If Option\Colourbandinlist = #True
    
    If Program\AlternateRow = #True
      
      Program\AlternateRow = #False
      
      SetGadgetItemColor(#Gadget_Mystuff_Itemlist, LineNumber.i, #PB_Gadget_BackColor,   $D4D4D4)
      
      SetGadgetItemColor(#Gadget_Mystuff_Itemlist, LineNumber.i, #PB_Gadget_FrontColor,  $000000)
      
    ElseIf Program\AlternateRow = #False
      
      Program\AlternateRow = #True
      
      SetGadgetItemColor(#Gadget_Mystuff_Itemlist, LineNumber.i, #PB_Gadget_BackColor,   $C1C1C1)
      
      SetGadgetItemColor(#Gadget_Mystuff_Itemlist, LineNumber.i, #PB_Gadget_FrontColor,  $FFFFFF)
      
    EndIf
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Mystuff\Locked = "1"
    
    SetGadgetItemImage(#Gadget_Mystuff_Itemlist, LineNumber.i, ImageID(#Image_Location_Lockedstuff))
    
  ElseIf  Mystuff\Locked <> "1"
    
    If Mystuff\Deleted = "1"
      
      SetGadgetItemData(#Gadget_Mystuff_Itemlist,  LineNumber.i, Val(Mystuff\Deleted))
      
      RedrawWindow_(GadgetID(#Gadget_Mystuff_Itemlist), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
      
      SetGadgetItemImage(#Gadget_Mystuff_Itemlist, LineNumber.i, ImageID(#Image_Location_Deletedstuff))
      
    ElseIf Mystuff\Deleted <> "1"
      
      If Mystuff\Favourite = "1"
        
        SetGadgetItemImage(#Gadget_Mystuff_Itemlist, LineNumber.i, ImageID(#Image_Location_Favouritestuff))
        
      ElseIf Mystuff\Favourite <> "1"
        
        SetGadgetItemImage(#Gadget_Mystuff_Itemlist, LineNumber.i, ImageID(#Image_Location_Normalstuff))
        
      EndIf
      
    EndIf
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 73
; Folding = -
; EnableXP