﻿;==========================================================================================================================================================
; Edit an older item in my stuff
;==========================================================================================================================================================

Procedure EditOldStuff()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Mystuffedit\CurrentLine = GetGadgetState(#Gadget_Mystuff_Itemlist)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Mystuffedit\CurrentLine  <>  #NoCurrentLine
    
      ;--------------------------------------------------------------------------------------------
      ; Get the lock state of the record
      ;--------------------------------------------------------------------------------------------
      
      LockedState.s   = GetGadgetItemText(#Gadget_Mystuff_Itemlist, Mystuffedit\CurrentLine, #LockedColumn)
      
      DeletedState.s  = GetGadgetItemText(#Gadget_Mystuff_Itemlist, Mystuffedit\CurrentLine, #DeletedColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; Is this record locked or marked as deleted?
      ;--------------------------------------------------------------------------------------------
      
      If LockedState.s <> "1" And DeletedState.s <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Mystuffedit\Mystuffid = GetGadgetItemText(#Gadget_Mystuff_Itemlist, Mystuffedit\CurrentLine, #RecordColumn)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Mystuffedit\Mystuffid  <>  #EmptyString
          
          
          ;----------------------------------------------------------------------------------------
          ; Check if another window isn't open first
          ;----------------------------------------------------------------------------------------
          
          If Program\WindowMutex <> #True
            
            ;--------------------------------------------------------------------------------------
            ; Check to see if the datasheet window could be opened
            ;--------------------------------------------------------------------------------------
            
            If Window_Datasheet()  <> #NoWindowId
              
              ;------------------------------------------------------------------------------------
              ; If there are no other open windows, set the window open flag
              ;------------------------------------------------------------------------------------
              
              Program\WindowMutex = #True
              
              ;------------------------------------------------------------------------------------
              ; Hack to include Kenmo's rating gadget instead of the string gadget
              ;------------------------------------------------------------------------------------
              
              ; StringGadget(#Gadget_Datasheet_Importance,160,339,110,25,"",#PB_String_ReadOnly|#PB_String_BorderLess)
              
              OpenGadgetList(#Gadget_Datasheet_cDetails)
              
              RatingGadget(#Gadget_Datasheet_Importance, 160,339,110,25)
              
              RatingGadget_SetMaximum(#Gadget_Datasheet_Importance, 6)  
              
              CloseGadgetList()
              
              ;------------------------------------------------------------------------------------
              ; Add this window's fast escape shortcut
              ;------------------------------------------------------------------------------------
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Escape,              #Shortcut_Datasheet_Escape)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Savemystuff,         #Shortcut_Datasheet_Savemystuff)
              
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_LookupModel,         #Shortcut_Datasheet_Lookupmodel)
              
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Menu_Addpicture,     #Shortcut_Datasheet_Menu_Addpicture)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Menu_Clearpicture,   #Shortcut_Datasheet_Menu_Clearpicture)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Menu_DeletePicture,  #Shortcut_Datasheet_Menu_DeletePicture)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_Menu_ScanPicture,    #Shortcut_Datasheet_Menu_ScanPicture)
              
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_AddPicture,          #Shortcut_Datasheet_AddPicture)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_ScanPicture,         #Shortcut_Datasheet_ScanPicture)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_AddDocument,         #Shortcut_Datasheet_AddDocument)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_ScanDocument,        #Shortcut_Datasheet_ScanDocument)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_ViewDocument,        #Shortcut_Datasheet_ViewDocument)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_RelinkDocument,      #Shortcut_Datasheet_RelinkDocument)
              
              AddKeyboardShortcut(#Window_Datasheet, #Keys_Datasheet_ExitMyStuff,         #Shortcut_Datasheet_ExitMyStuff)
        
              ;------------------------------------------------------------------------------------
              ; These are your balloon tooltips used on the main form. All headings, balloon text
              ; and icons are re-useable variables taken from the constants file.
              ;------------------------------------------------------------------------------------
              
              If Program\BalloonFontId
                
                BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Savemystuff,    Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Savemystuff,    #CRLF$ + GetShortCutText(#Keys_Datasheet_Savemystuff)     + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Savemystuff,     30),  GetIconHandle(#Image_Datasheet_Savemystuff))
                
                BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Addpicture,     Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Addpicture,     #CRLF$ + GetShortCutText(#Keys_Datasheet_Addpicture)      + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Addpicture,      30),  GetIconHandle(#Image_Datasheet_Addpicture))
                
                BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Scanpicture,    Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Scanpicture,    #CRLF$ + GetShortCutText(#Keys_Datasheet_Scanpicture)     + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Scanpicture,     30),  GetIconHandle(#Image_Datasheet_Scanpicture))
                
                BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Scandocument,   Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Scandocument,   #CRLF$ + GetShortCutText(#Keys_Datasheet_Scandocument)    + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Scandocument,    30),  GetIconHandle(#Image_Datasheet_Scandocument))
                
                BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Adddocument,    Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Adddocument,    #CRLF$ + GetShortCutText(#Keys_Datasheet_Adddocument)     + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Adddocument,     30),  GetIconHandle(#Image_Datasheet_Adddocument))
                
                BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Viewdocument,   Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Viewdocument,   #CRLF$ + GetShortCutText(#Keys_Datasheet_Viewdocument)    + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Viewdocument,    30),  GetIconHandle(#Image_Datasheet_Viewdocument))
                
                BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Relinkdocument, Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Relinkdocument, #CRLF$ + GetShortCutText(#Keys_Datasheet_Relinkdocument)  + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Relinkdocument,  30),  GetIconHandle(#Image_Datasheet_Relinkdocument))
                
                BalloonToolTip(#Window_Mystuff, #Gadget_Datasheet_Exitmystuff,    Program\BalloonFontId, $FFFFFF, #Keystext_Datasheet_Exitmystuff,    #CRLF$ + GetShortCutText(#Keys_Datasheet_Exitmystuff)     + #CRLF$ + #CRLF$ + WordWrapString(#LongKeysText_Datasheet_Exitmystuff,     30),  GetIconHandle(#Image_Datasheet_Exitmystuff))
                
              Else
                
                MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
                
              EndIf
      
              ;------------------------------------------------------------------------------------
              ; Add the hoverable controls
              ;------------------------------------------------------------------------------------
              
              AddHoverGadget(GadgetID(#Gadget_Datasheet_iLookupModel))
              
              AddHoverGadget(GadgetID(#Gadget_Datasheet_SaveMyStuff))
              
              AddHoverGadget(GadgetID(#Gadget_Datasheet_AddPicture))
              
              AddHoverGadget(GadgetID(#Gadget_Datasheet_Scanpicture))
              
              AddHoverGadget(GadgetID(#Gadget_Datasheet_AddDocument))
              
              AddHoverGadget(GadgetID(#Gadget_Datasheet_ScanDocument))
              
              AddHoverGadget(GadgetID(#Gadget_Datasheet_ViewDocument))
              
              AddHoverGadget(GadgetID(#Gadget_Datasheet_RelinkDocument))
              
              AddHoverGadget(GadgetID(#Gadget_Datasheet_ExitMyStuff))
              
              ;------------------------------------------------------------------------------------
              ; Disable all input on the main window until this one is closed
              ;------------------------------------------------------------------------------------
              
              DisableWindow(#Window_Mystuff, #True)
              
              ;------------------------------------------------------------------------------------
              ; Hide the main window until we are finished with the data window
              ;------------------------------------------------------------------------------------
              
              HideWindow(#Window_Mystuff, #True)
              
              ;------------------------------------------------------------------------------------
              ; Add the window title for various procedures and visuals
              ;------------------------------------------------------------------------------------
              
              Program\LastWindow = "Edit Old Stuff"      
              
              ;------------------------------------------------------------------------------------
              ; Fill the various combobox fields with data from the database
              ;------------------------------------------------------------------------------------
              
              FillCombo(#Gadget_Datasheet_Supplier,       "SELECT DISTINCT Supplier FROM Mystuff ORDER BY Supplier")
              
              FillCombo(#Gadget_Datasheet_Manufacturer,   "SELECT DISTINCT Manufacturer FROM Mystuff ORDER BY Manufacturer")
              
              FillCombo(#Gadget_Datasheet_Working,        "SELECT DISTINCT Working FROM Mystuff ORDER BY Working")
              
              FillCombo(#Gadget_Datasheet_WhoPaid,        "SELECT DISTINCT Whopaid FROM Mystuff ORDER BY Whopaid")
              
              FillCombo(#Gadget_Datasheet_OwnerName,      "SELECT DISTINCT Ownername FROM Mystuff ORDER BY Ownername")
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              DatabaseQuery.s = "SELECT Location, Filename "
              
              DatabaseQuery.s + "FROM Locations "
              
              DatabaseQuery.s + "ORDER BY Location"
              
              If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
                
                While NextDatabaseRow(Program\DatabaseHandle)
                  
                  LocationString.s = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
                  
                  UsericonString.s = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1))
                  
                  If LocationString.s <> #EmptyString
                    
                    UserIconHandle.i = LoadImage(#PB_Any, Program\IconsDirectory  + UsericonString.s)
                    
                    If UserIconHandle.i <>  #NoPictureLoaded
                      
                      AddGadgetItem(#Gadget_Datasheet_Location, #AtTheEndOfTheList, LocationString.s, ImageID(UserIconHandle.i))
                      
                    Else
                      
                      SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
                      
                    EndIf
                    
                  EndIf
                  
                Wend
                
                FinishDatabaseQuery(Program\DatabaseHandle)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
          
              FillCombo(#Gadget_Datasheet_Condition,      "SELECT DISTINCT Condition FROM Mystuff ORDER BY Condition")
              
              FillCombo(#Gadget_Datasheet_Category,       "SELECT DISTINCT Category FROM Mystuff ORDER BY Category")
              
              FillCombo(#Gadget_Datasheet_Loanedto,       "SELECT DISTINCT Loanedto FROM Mystuff ORDER BY Loanedto")
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
             ;FillCombo(#Gadget_Datasheet_PaidBy,         "SELECT DISTINCT Paidby FROM Mystuff ORDER BY Paidby")
              
              AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Unknown",        ImageID(#Image_Datasheet_Unknown))
              
              AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Bank transfer",  ImageID(#Image_Datasheet_Banktransfer))
              
              AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Cash",           ImageID(#Image_Datasheet_Cash))
              
              AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Cheque",         ImageID(#Image_Datasheet_Cheque))
              
              AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Eftpos",         ImageID(#Image_Datasheet_Eftpos))
              
              AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Mastercard",     ImageID(#Image_Datasheet_Mastercard))
              
              AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Paypal",         ImageID(#Image_Datasheet_Paypal))
              
              AddGadgetItem(#Gadget_Datasheet_PaidBy, #AtTheEndOfTheList, "Visa",           ImageID(#Image_Datasheet_Visa))
        
              SetGadgetState(#Gadget_Datasheet_PaidBy, #FirstItem)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FillCombo(#Gadget_Datasheet_WarrantyWord,   "SELECT DISTINCT Warrantyword FROM Mystuff ORDER BY Warrantyword")
              
              FillCombo(#Gadget_Datasheet_WarrantyActive, "SELECT DISTINCT Warrantyactive FROM Mystuff ORDER BY Warrantyactive")
              
              FillCombo(#Gadget_Datasheet_Insured,        "SELECT DISTINCT Insured FROM Mystuff ORDER BY Insured")
              
              FillCombo(#Gadget_Datasheet_InsurerName,    "SELECT DISTINCT Insurername FROM Mystuff ORDER BY Insurername")
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetGadgetState(#Gadget_Datasheet_BoughtOn, #False)
              
              SetGadgetState(#Gadget_Datasheet_InsuredOn, #False)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
            
              CleanDirectory(Program\TemporaryDirectory)
              
              ;------------------------------------------------------------------------------------
              ; Add a generic message for info bars and title areas
              ;------------------------------------------------------------------------------------
              
              Message.s = "Edit old stuff in your inventory"
              
              ;------------------------------------------------------------------------------------
              ; Setup the nextrecord generic string message
              ;------------------------------------------------------------------------------------
              
              NextRecordString.s  = "   --   Record number: " + Mystuffedit\Mystuffid
              
              ;------------------------------------------------------------------------------------
              ; Set the window title bar with the record number and message
              ;------------------------------------------------------------------------------------
              
              SetWindowTitle(#Window_Datasheet, Message.s + NextRecordString.s)
              
              ;------------------------------------------------------------------------------------
              ; Setup the database query to fetch the right record
              ;------------------------------------------------------------------------------------
              
              DatabaseQuery.s = "SELECT * FROM Mystuff "
              
              DatabaseQuery.s + "WHERE Mystuffid = '" + Mystuffedit\Mystuffid + "'"
    
              ;------------------------------------------------------------------------------------
              ; Fetch the record data for this record
              ;------------------------------------------------------------------------------------
              
              If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
                
                While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
                  
                  Mystuff\Itemname          =  GetDatabaseString(Program\DatabaseHandle,  0)
                  
                  Mystuff\Supplier          =  GetDatabaseString(Program\DatabaseHandle,  1)
                  
                  Mystuff\Manufacturer      =  GetDatabaseString(Program\DatabaseHandle,  2)
                  
                  Mystuff\Modelnumber       =  GetDatabaseString(Program\DatabaseHandle,  3)
                  
                  Mystuff\Serialnumber      =  GetDatabaseString(Program\DatabaseHandle,  4)
                  
                  Mystuff\Barcode           =  GetDatabaseString(Program\DatabaseHandle,  5)
                  
                  Mystuff\Boughton          =  GetDatabaseString(Program\DatabaseHandle,  6)
                  
                  Mystuff\Working           =  GetDatabaseString(Program\DatabaseHandle,  7)
                  
                  Mystuff\Whopaid           =  GetDatabaseString(Program\DatabaseHandle,  8)
                  
                  Mystuff\Ownername         =  GetDatabaseString(Program\DatabaseHandle,  9)
                  
                  Mystuff\Location          =  GetDatabaseString(Program\DatabaseHandle, 10)
                  
                  Mystuff\Condition         =  GetDatabaseString(Program\DatabaseHandle, 11)
                  
                  Mystuff\Category          =  GetDatabaseString(Program\DatabaseHandle, 12)
                  
                  Mystuff\Importance        =    GetDatabaseLong(Program\DatabaseHandle, 13)
                  
                  Mystuff\Loanedto          =  GetDatabaseString(Program\DatabaseHandle, 14)
                  
                  Mystuff\Comments          =  GetDatabaseString(Program\DatabaseHandle, 15)
                  
                  Mystuff\Itempicture       =  GetDatabaseString(Program\DatabaseHandle, 16)
                  
                  Mystuff\Itemdocument      =  GetDatabaseString(Program\DatabaseHandle, 17)
                  
                  Mystuff\Cost              =  GetDatabaseString(Program\DatabaseHandle, 18)
                  
                  Mystuff\Tax               =  GetDatabaseString(Program\DatabaseHandle, 19)
                  
                  Mystuff\Delivery          =  GetDatabaseString(Program\DatabaseHandle, 20)
                  
                  Mystuff\Othercost         =  GetDatabaseString(Program\DatabaseHandle, 21)
                  
                  Mystuff\Resale            =  GetDatabaseString(Program\DatabaseHandle, 22)
                  
                  Mystuff\Paidby            =  GetDatabaseString(Program\DatabaseHandle, 23)
                  
                  Mystuff\Warrantyperiod    =  GetDatabaseString(Program\DatabaseHandle, 24)
                  
                  Mystuff\Warrantyword      =  GetDatabaseString(Program\DatabaseHandle, 25)
                  
                  Mystuff\Warrantyactive    =  GetDatabaseString(Program\DatabaseHandle, 26)
                  
                  Mystuff\Warrantyextra     =  GetDatabaseString(Program\DatabaseHandle, 27)
                  
                  Mystuff\Insured           =  GetDatabaseString(Program\DatabaseHandle, 28)
                  
                  Mystuff\Insuredamount     =  GetDatabaseString(Program\DatabaseHandle, 29)
                  
                  Mystuff\Insuredon         =  GetDatabaseString(Program\DatabaseHandle, 30)
                  
                  Mystuff\Insurername       =  GetDatabaseString(Program\DatabaseHandle, 31)
                  
                  Mystuff\Policynumber      =  GetDatabaseString(Program\DatabaseHandle, 32)
                  
                  Mystuff\Contactnumber     =  GetDatabaseString(Program\DatabaseHandle, 33)
                  
                  Mystuff\Contactname       =  GetDatabaseString(Program\DatabaseHandle, 34)
                  
                  Mystuff\Contactdepartment =  GetDatabaseString(Program\DatabaseHandle, 35)
                  
                  Mystuff\Deleted           =  GetDatabaseString(Program\DatabaseHandle, 36)
                  
                  Mystuff\Favourite         =  GetDatabaseString(Program\DatabaseHandle, 37)
                  
                  Mystuff\Locked            =  GetDatabaseString(Program\DatabaseHandle, 38)
                  
                  Mystuff\Mystuffid         =  GetDatabaseString(Program\DatabaseHandle, 39)
                  
                Wend
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                FinishDatabaseQuery(Program\DatabaseHandle)
                
                ;----------------------------------------------------------------------------------
                ; Set the data to this form
                ;----------------------------------------------------------------------------------
                
                SetGadgetText(#Gadget_Datasheet_ItemName,                   Mystuff\Itemname)
                
                SetGadgetText(#Gadget_Datasheet_Supplier,                   Mystuff\Supplier)
                
                SetGadgetText(#Gadget_Datasheet_Manufacturer,               Mystuff\Manufacturer)
                
                SetGadgetText(#Gadget_Datasheet_ModelNumber,                Mystuff\Modelnumber)
                
                SetGadgetText(#Gadget_Datasheet_SerialNumber,               Mystuff\Serialnumber)
                
                SetGadgetText(#Gadget_Datasheet_Barcode,                    Mystuff\Barcode)
                
                If Mystuff\Boughton <>  #EmptyString
                  
                  SetGadgetState(#Gadget_Datasheet_BoughtOn, ParseDate("%yyyy-%mm-%dd", Mystuff\Boughton))
                  
                EndIf
                
                SetGadgetText(#Gadget_Datasheet_Working,                    Mystuff\Working)
                
                SetGadgetText(#Gadget_Datasheet_WhoPaid,                    Mystuff\Whopaid)
                
                SetGadgetText(#Gadget_Datasheet_OwnerName,                  Mystuff\Ownername)
                
                SetGadgetText(#Gadget_Datasheet_Location,                   Mystuff\Location)
                
                SetGadgetText(#Gadget_Datasheet_Condition,                  Mystuff\Condition)
                
                SetGadgetText(#Gadget_Datasheet_Category,                   Mystuff\Category)
                
                RatingGadget_SetState(#Gadget_Datasheet_Importance,         Mystuff\Importance)
                
                SetGadgetText(#Gadget_Datasheet_Comments,                   Mystuff\Comments)
                
                                                               LoadOldPicture(Mystuff\Itempicture)
                                                                  
                                             Mystuffedit\Oldpicturetokeep = Mystuff\ItemPicture
    
                SetGadgetText(#Gadget_Datasheet_Cost,           GetCurrency(Mystuff\Cost))
                
                SetGadgetText(#Gadget_Datasheet_Tax,            GetCurrency(Mystuff\Tax))
                
                SetGadgetText(#Gadget_Datasheet_Delivery,       GetCurrency(Mystuff\Delivery))
                
                SetGadgetText(#Gadget_Datasheet_Othercost,      GetCurrency(Mystuff\Othercost))
                
                SetGadgetText(#Gadget_Datasheet_Resale,         GetCurrency(Mystuff\Resale))
                
                If Mystuff\Paidby <> #EmptyString
                  
                  SetGadgetText(#Gadget_Datasheet_PaidBy,                     Mystuff\Paidby)
                  
                Else
                  
                  SetGadgetText(#Gadget_Datasheet_PaidBy,                     "Unknown")
                  
                EndIf
                
                SetGadgetText(#Gadget_Datasheet_WarrantyPeriod,             Mystuff\Warrantyperiod)
                
                SetGadgetText(#Gadget_Datasheet_WarrantyWord,               Mystuff\Warrantyword)
                
                SetGadgetText(#Gadget_Datasheet_WarrantyActive,             Mystuff\Warrantyactive)
                
                SetGadgetText(#Gadget_Datasheet_WarrantyAmount, GetCurrency(Mystuff\Warrantyextra))
                
                SetGadgetText(#Gadget_Datasheet_Insured,                    Mystuff\Insured)
                
                SetGadgetText(#Gadget_Datasheet_InsuredAmount,  GetCurrency(Mystuff\Insuredamount))
                
                If Mystuff\Insuredon <>  #EmptyString
                  
                  SetGadgetState(#Gadget_Datasheet_InsuredOn, ParseDate("%yyyy-%mm-%dd", Mystuff\Insuredon))
                  
                EndIf
                
                SetGadgetText(#Gadget_Datasheet_InsurerName,                Mystuff\Insurername)
                
                SetGadgetText(#Gadget_Datasheet_PolicyNumber,               Mystuff\Policynumber)
                
                SetGadgetText(#Gadget_Datasheet_ContactNumber,              Mystuff\Contactnumber)
                
                SetGadgetText(#Gadget_Datasheet_Contactname,                Mystuff\Contactname)
                
                SetGadgetText(#Gadget_Datasheet_Contactdepartment,          Mystuff\Contactdepartment)
                
                SetGadgetText(#Gadget_Datasheet_Documentname,               Mystuff\Itemdocument)
                
                If FileSize(Program\DocumentDirectory + Mystuff\ItemDocument) = #FileDoesNotExist
                  
                  SetGadgetColor(#Gadget_Datasheet_Documentname, #PB_Gadget_BackColor, $0000EC)
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings",  "Error", "Database query failed or returned no data:  " + DatabaseError(), #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; Make sure this window is active for input
              ;------------------------------------------------------------------------------------
              
              SetActiveWindow(#Window_Datasheet)
              
              ;------------------------------------------------------------------------------------
              ; Make sure the itemname field is ready for input
              ;------------------------------------------------------------------------------------
              
              SetActiveGadget(#Gadget_Datasheet_ItemName)
              
              ;------------------------------------------------------------------------------------
              ; Add the generic message to this windows fake status area
              ;------------------------------------------------------------------------------------
              
              SetGadgetText(#Gadget_Datasheet_sStatusbar,  Message.s)
              
              ;------------------------------------------------------------------------------------
              ; Add the message to the main window fake status area
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings",  "Info",  Message.s + NextRecordString.s, #PB_Compiler_Procedure)
              
              ;------------------------------------------------------------------------------------
              ; Go here if we could not open this data sheet window
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings",  "Warn",  "Could not open the "  + Program\LastWindow  + " window", #PB_Compiler_Procedure)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; Go here if there is another program window open. Programmer error
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Error",  Program\LastWindow + " is still open bozo, close that one first", #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; Nothing more to do folks
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "There is no record number for that item. Should never happen.", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        If LockedState.s = "1"
          
          Message.s = "Locked"
          
        EndIf
        
        If DeletedState.s = "1"
          
          Message.s = "Deleted"
          
        EndIf
        
        SetInfoBarArea("Headings",  "Warn", "This record is marked as " + Message.s + "so editing is not allowed.", #PB_Compiler_Procedure)
        
        MessageRequester(Message.s, "This record is marked as " + Message.s + #CRLF$ + "so editing is not allowed." + #CRLF$ + #CRLF$ + "it must be Un"  + Message.s + " first", #PB_MessageRequester_Ok)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "There is no current item selected for editing.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 87
; FirstLine = 348
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog