﻿;==========================================================================================================================================================
; Show my stuff for the currently selected location
;==========================================================================================================================================================

Procedure GetMyStuffForLocation()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Location\Currentline  = GetGadgetState(#Gadget_Mystuff_Locations)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Location\Currentline <> #NoCurrentLine
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Location\Location = Trim(StringField(GetGadgetItemText(#Gadget_Mystuff_Locations, Location\CurrentLine, #LocationTitleColumn), 1, "("))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Location\Location <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select Location\Location
          
        Case "All my stuff"     : DatabaseQuery.s = "SELECT * FROM Mystuff WHERE Deleted = '0' AND Locked = '0' ORDER BY Itemname LIMIT 25"
          
        Case "No titles"        : DatabaseQuery.s = "SELECT * FROM Mystuff WHERE Itemname = '' ORDER BY Itemname LIMIT 25"
          
        Case "No locations"     : DatabaseQuery.s = "SELECT * FROM Mystuff WHERE Location = '' ORDER BY Itemname LIMIT 25"
          
        Case "Deleted stuff"    : DatabaseQuery.s = "SELECT * FROM Mystuff WHERE Deleted = '1' ORDER BY Itemname LIMIT 25"
          
        Case "Favourite stuff"  : DatabaseQuery.s = "SELECT * FROM Mystuff WHERE Favourite = '1' ORDER BY Itemname LIMIT 25"
          
        Case "Locked stuff"     : DatabaseQuery.s = "SELECT * FROM Mystuff WHERE Locked = '1' ORDER BY Itemname LIMIT 25"
          
        Case "Loaned stuff"     : DatabaseQuery.s = "SELECT * FROM Mystuff WHERE Loanedto = '1' ORDER BY Itemname LIMIT 25"
          
        Case "-----------------------"  
          
        Default
          
          DatabaseQuery.s = "SELECT * FROM Mystuff "
          
          DatabaseQuery.s + "WHERE Location LIKE '%"  + RepQuote(Location\Location) + "%' "
          
          DatabaseQuery.s + "ORDER BY Itemname "
          
          DatabaseQuery.s + " LIMIT 25"
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ;ClearGadgetItems(#Gadget_Mystuff_Itemlist)
      
      ;--------------------------------------------------------------------------------------------
      ; Set the initial total item value string
      ;--------------------------------------------------------------------------------------------
    
      Program\TotalCost.d     = 0
      
      ;--------------------------------------------------------------------------------------------
      ; Set the initial total item value string
      ;--------------------------------------------------------------------------------------------

      SetInfoBarArea("Total",  #EmptyString, StrD(Program\TotalCost.d, 2), #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      LineCounter.i = #NoItems
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery.s  <> #EmptyString
        
        If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
          
          ClearGadgetItems(#Gadget_Mystuff_Itemlist)
          
          While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
            
            Mystuff\Itemname          =  GetDatabaseString(Program\DatabaseHandle,  0)
            
            Mystuff\Supplier          =  GetDatabaseString(Program\DatabaseHandle,  1)
            
            Mystuff\Manufacturer      =  GetDatabaseString(Program\DatabaseHandle,  2)
            
            Mystuff\Modelnumber       =  GetDatabaseString(Program\DatabaseHandle,  3)
            
            Mystuff\Serialnumber      =  GetDatabaseString(Program\DatabaseHandle,  4)
            
            Mystuff\Barcode           =  GetDatabaseString(Program\DatabaseHandle,  5)
            
            Mystuff\Boughton          =  GetDatabaseString(Program\DatabaseHandle,  6)
            
            Mystuff\Working           =  GetDatabaseString(Program\DatabaseHandle,  7)
            
            Mystuff\Whopaid           =  GetDatabaseString(Program\DatabaseHandle,  8)
            
            Mystuff\Ownername         =  GetDatabaseString(Program\DatabaseHandle,  9)
            
            Mystuff\Location          =  GetDatabaseString(Program\DatabaseHandle, 10)
            
            Mystuff\Condition         =  GetDatabaseString(Program\DatabaseHandle, 11)
            
            Mystuff\Category          =  GetDatabaseString(Program\DatabaseHandle, 12)
            
            Mystuff\Importance        =    GetDatabaseLong(Program\DatabaseHandle, 13)
            
            Mystuff\Loanedto          =  GetDatabaseString(Program\DatabaseHandle, 14)
            
            Mystuff\Comments          =  GetDatabaseString(Program\DatabaseHandle, 15)
            
            Mystuff\Itempicture       =  GetDatabaseString(Program\DatabaseHandle, 16)
            
            Mystuff\Itemdocument      =  GetDatabaseString(Program\DatabaseHandle, 17)
            
            Mystuff\Cost              =  GetDatabaseString(Program\DatabaseHandle, 18)
            
            Mystuff\Tax               =  GetDatabaseString(Program\DatabaseHandle, 19)
            
            Mystuff\Delivery          =  GetDatabaseString(Program\DatabaseHandle, 20)
            
            Mystuff\Othercost         =  GetDatabaseString(Program\DatabaseHandle, 21)
            
            Mystuff\Resale            =  GetDatabaseString(Program\DatabaseHandle, 22)
            
            Mystuff\Paidby            =  GetDatabaseString(Program\DatabaseHandle, 23)
            
            Mystuff\Warrantyperiod    =  GetDatabaseString(Program\DatabaseHandle, 24)
            
            Mystuff\Warrantyword      =  GetDatabaseString(Program\DatabaseHandle, 25)
            
            Mystuff\Warrantyactive    =  GetDatabaseString(Program\DatabaseHandle, 26)
            
            Mystuff\Warrantyextra     =  GetDatabaseString(Program\DatabaseHandle, 27)
            
            Mystuff\Insured           =  GetDatabaseString(Program\DatabaseHandle, 28)
            
            Mystuff\Insuredamount     =  GetDatabaseString(Program\DatabaseHandle, 29)
            
            Mystuff\Insuredon         =  GetDatabaseString(Program\DatabaseHandle, 30)
            
            Mystuff\Insurername       =  GetDatabaseString(Program\DatabaseHandle, 31)
            
            Mystuff\Policynumber      =  GetDatabaseString(Program\DatabaseHandle, 32)
            
            Mystuff\Contactnumber     =  GetDatabaseString(Program\DatabaseHandle, 33)
            
            Mystuff\Contactname       =  GetDatabaseString(Program\DatabaseHandle, 34)
            
            Mystuff\Contactdepartment =  GetDatabaseString(Program\DatabaseHandle, 35)
            
            Mystuff\Deleted           =  GetDatabaseString(Program\DatabaseHandle, 36)
            
            Mystuff\Favourite         =  GetDatabaseString(Program\DatabaseHandle, 37)
            
            Mystuff\Locked            =  GetDatabaseString(Program\DatabaseHandle, 38)
            
            Mystuff\Mystuffid         =  GetDatabaseString(Program\DatabaseHandle, 39)
              
            DisplayMystuffString(LineCounter.i, "Add New Stuff")
            
            Program\TotalCost.d             + ValD(ClearCurrencyFormat(Mystuff\Cost))
            
            SetInfoBarArea("Total",  #EmptyString, StrD(Program\TotalCost.d, 2), #PB_Compiler_Procedure)
            
            LineCounter.i + 1
            
          Wend
          
          FinishDatabaseQuery(Program\DatabaseHandle)
          
        Else
  
          SetInfoBarArea("Headings",  "Error", "Database query failed or returned no data:  " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Info", "No location specified, nothing to do now..", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Warn", "Location string is empty, nothing to search for.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info", "Nothing to display as user has not selected a location.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;--------------------------------------------------------------------------------------------------
  ; 
  ;--------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 178
; FirstLine = 163
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP