﻿;==========================================================================================================================================================
; Load a linked Picture for the passed picture name
;==========================================================================================================================================================

Procedure LoadOldPicture(Picturename.s)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Picturename.s <> #EmptyString
    
    If FileSize(Program\PictureDirectory + Picturename.s)  <> #FileDoesNotExist
      
      DatasheetPictureId.i = LoadImage(#PB_Any, Program\PictureDirectory + Picturename.s)
      
      If DatasheetPictureId.i <> #NoPictureHandle
        
        NewImageHandle.i = ResizeImage(DatasheetPictureId.i, #DatasheetPictureWidth, #DatasheetPictureHeight, #PB_Image_Smooth)
        
        If NewImageHandle.i
          
          SetGadgetState(#Gadget_Datasheet_ItemPicture, NewImageHandle.i)
          
          SetGadgetText(#Gadget_Datasheet_Picturename, Picturename.s)
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "Could not resize the loaded picture to the picture frame.", #PB_Compiler_Procedure)
          
        EndIf
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  "The Picture requested for this stuff could not be loaded from disk.", #PB_Compiler_Procedure)
        
      EndIf
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "The Picture requested for this stuff does not exist.", #PB_Compiler_Procedure)
      
    EndIf
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "There is no current Picture to load for this stuff.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP