﻿;==========================================================================================================================================================
; Lock the currently selected stuff
;==========================================================================================================================================================

Procedure LockThisStuff()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected CurrentLine.i, CurrentLocation.s, FavouriteState.s, LockedState.s,  DeletedState.s
  
  Protected CurrentRecord.s
  
  ;------------------------------------------------------------------------------------------------
  ; Get the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i     = GetGadgetState(#Gadget_Mystuff_Itemlist)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLocation.s = GetGadgetText(#Gadget_Mystuff_Locations)
  
  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current toggle states
    ;----------------------------------------------------------------------------------------------
    
    FavouriteState.s = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #FavouriteColumn)
    
    LockedState.s    = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #LockedColumn)
    
    DeletedState.s   = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #DeletedColumn)
    
    CurrentRecord.s  = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DeletedState <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If  LockedState.s = "0"
        
        LockedState.s = "1"
        
      ElseIf  LockedState.s = "1"
        
        LockedState.s = "0"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Proceed if we got a record number
      ;--------------------------------------------------------------------------------------------
      
      If CurrentRecord.s <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; Try to delete the selected record from the database
        ;------------------------------------------------------------------------------------------
        
        UpdateString.s = "UPDATE Mystuff "
        
        UpdateString.s + "SET Locked  = "       + Val(LockedState.s)  + " "
        
        UpdateString.s + "WHERE Mystuffid = '"  + CurrentRecord.s     + "'"
        
        ;------------------------------------------------------------------------------------------
        ; Try to delete the selected record from the database
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) <> #DatabaseUpdateFail
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If LockedState.s = "1"
            
            SetGadgetItemImage(#Gadget_Mystuff_Itemlist, CurrentLine.i, ImageID(#Image_Location_Lockedstuff))
            
          ElseIf  LockedState.s <> "1"
            
            If DeletedState.s = "1"
              
              SetGadgetItemData(#Gadget_Mystuff_Itemlist, CurrentLine.i, Val(DeletedState.s))
              
              SetGadgetItemImage(#Gadget_Mystuff_Itemlist, CurrentLine.i, ImageID(#Image_Location_Deletedstuff))
              
              RedrawWindow_(GadgetID(#Gadget_Mystuff_Itemlist), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
              
            ElseIf DeletedState.s <> "1"
              
              If FavouriteState.s = "1"
                
                SetGadgetItemImage(#Gadget_Mystuff_Itemlist, CurrentLine.i, ImageID(#Image_Location_Favouritestuff))
                
              ElseIf FavouriteState.s <> "1"
                
                SetGadgetItemImage(#Gadget_Mystuff_Itemlist, CurrentLine.i, ImageID(#Image_Location_Normalstuff))
                
              EndIf
              
            EndIf
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetItemText(#Gadget_Mystuff_Itemlist,  CurrentLine.i, LockedState.s, #LockedColumn)
          
          ;----------------------------------------------------------------------------------------
          ; Remove the item from the current view if it doesn't match the shown category
          ;----------------------------------------------------------------------------------------
          
          If CurrentLocation.s <> "Locked stuff" And LockedState.s = "1"
            
            If CurrentLocation.s  <> "All my stuff" 
              
              RemoveGadgetItem(#Gadget_Mystuff_Itemlist, CurrentLine.i)
            
            EndIf
          
          ElseIf  CurrentLocation.s = "Locked stuff" And LockedState.s = "0"
          
            RemoveGadgetItem(#Gadget_Mystuff_Itemlist, CurrentLine.i)
          
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The database query failed: " + DatabaseError(), #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", "No record number found for line " + Str(CurrentLine.i), #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "You cannot lock a deleted recipe, undelete it first.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no current line selected.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 150
; FirstLine = 143
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP