﻿;==============================================================================================================================================================================
; Show a bigger version of the stored picture
;==============================================================================================================================================================================

Procedure Pictureofstuff()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_Mystuff_Itemlist)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i  <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CurrentRecord.s = GetGadgetItemText(#Gadget_Mystuff_Itemlist, CurrentLine.i,  #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CurrentRecord.s  <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; Check if an existing window is opened
      ;--------------------------------------------------------------------------------------------
      
      If Program\WindowMutex <> #True
        
        ;------------------------------------------------------------------------------------------
        ; Try to open the data form window
        ;------------------------------------------------------------------------------------------
        
        If Window_Pictureofstuff()
          
          ;----------------------------------------------------------------------------------------
          ; Window was opened so set mutex to prevent other windows from opening
          ;----------------------------------------------------------------------------------------
          
          Program\WindowMutex = #True
          
          ;----------------------------------------------------------------------------------------
          ; Prevent user input on the main window
          ;----------------------------------------------------------------------------------------
          
          DisableWindow(#Window_Mystuff, #True)
          
          ;----------------------------------------------------------------------------------------
          ; Setup the common add window message
          ;----------------------------------------------------------------------------------------
          
          Message.s = "View Current Picture"
          
          ;----------------------------------------------------------------------------------------
          ; Set the last window message for the closure routine later
          ;----------------------------------------------------------------------------------------
          
          Program\LastWindow = Message.s
          
          ;----------------------------------------------------------------------------------------
          ; Add the fast form close keyboard shortcut
          ;----------------------------------------------------------------------------------------
          
          AddKeyboardShortcut(#Window_Pictureofstuff, #Keys_Pictureofstuff_Escape,  #Shortcut_Pictureofstuff_Escape)
          
          ;----------------------------------------------------------------------------------------
          ;
          ;----------------------------------------------------------------------------------------
          
          QueryString.s = "SELECT Itemname, Itempicture "
          
          QueryString.s + "FROM Mystuff "
          
          QueryString.s + "WHERE Mystuffid = '" + CurrentRecord.s + "'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            While NextDatabaseRow(Program\DatabaseHandle)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              ItemName.s               = KillQuote(GetDatabaseString(Program\DatabaseHandle,   0))
              
              PictureFileName.s        = KillQuote(GetDatabaseString(Program\DatabaseHandle,   1))
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Wend
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            FinishDatabaseQuery(Program\DatabaseHandle)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetWindowTitle(#Window_Pictureofstuff, GetWindowTitle(#Window_Pictureofstuff) + " - Title ("  + ItemName.s + ")")
            
            ;--------------------------------------------------------------------------------------
            ;
            ;--------------------------------------------------------------------------------------
            
            If PictureFileName.s <> #EmptyString
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              PictureHandle.i       = LoadImage(#PB_Any, Program\PictureDirectory + PictureFileName.s)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If PictureHandle.i
                ;------------------------------------------------------------------------------------
                ; 
                ;------------------------------------------------------------------------------------
                
                WindowsFrameWidth.i   = (WindowWidth(#Window_Pictureofstuff,   #PB_Window_FrameCoordinate) - WindowWidth(#Window_Pictureofstuff,  #PB_Window_InnerCoordinate))
                
                WindowsFrameHeigth.i  = (WindowHeight(#Window_Pictureofstuff,  #PB_Window_FrameCoordinate) - WindowHeight(#Window_Pictureofstuff, #PB_Window_InnerCoordinate))
                
                TaskBarHeight.i       = GetWindowTitleBarDetails(#Window_Pictureofstuff)
                
                ;------------------------------------------------------------------------------------
                ; 
                ;------------------------------------------------------------------------------------
                
                PictureWidth.i        = ImageWidth(PictureHandle.i)     ; HorizontalWidth.i
                
                PictureHeight.i       = ImageHeight(PictureHandle.i)    ; VerticalHeight.i
                
                ;------------------------------------------------------------------------------------
                ; 
                ;------------------------------------------------------------------------------------
                
                MaxInnerWidth.i       = Program\DesktopWidth  - WindowsFrameWidth.i
                
                MaxInnerHeight        = Program\DesktopHeight - WindowsFrameHeigth.i - TaskBarHeight.i
                
                ;------------------------------------------------------------------------------------
                ; 
                ;------------------------------------------------------------------------------------
                
                WidthFactor.f   = 1.0
                
                HeightFactor.f  = 1.0
                
                Factor.f        = 1.0
                
                ;------------------------------------------------------------------------------------
                ; 
                ;------------------------------------------------------------------------------------
                
                If PictureWidth.i > MaxInnerWidth.i
                  
                  WidthFactor.f   = MaxInnerWidth.i / PictureWidth.i
                  
                EndIf
                
                If PictureHeight.i > MaxInnerHeight.i
                  
                  HeightFactor.f   = MaxInnerHeight.i / PictureHeight.i
                  
                EndIf
                
                If WidthFactor.f < HeightFactor.f
                  
                  Factor.f       = WidthFactor.f
                  
                EndIf
                
                If HeightFactor.f < WidthFactor.f
                  
                  Factor.f        = HeightFactor.f
                  
                EndIf
                
                ;------------------------------------------------------------------------------------
                ; 
                ;------------------------------------------------------------------------------------
                
                NewWindowWidth.i  = PictureWidth.i  * Factor.f
                
                NewWindowHeight.i = PictureHeight.i * Factor.f            
                
                ;------------------------------------------------------------------------------------
                ; 
                ;------------------------------------------------------------------------------------
                
                If PictureHandle.i  <> #NoPictureHandle
                  
                  ResizeWindow(#Window_Pictureofstuff, (Program\DesktopWidth - NewWindowWidth.i - WindowsFrameWidth.i) / 2, (Program\DesktopHeight - NewWindowHeight.i - WindowsFrameHeigth.i - TaskBarHeight.i) / 2, NewWindowWidth.i, NewWindowHeight.i)
                  
                  ResizeImage(PictureHandle.i, NewWindowWidth.i, NewWindowHeight.i, #PB_Image_Smooth)
                  
                  SetGadgetState(#Gadget_Pictureofstuff_Picture, ImageID(PictureHandle.i))
                  
                EndIf
                
                ;------------------------------------------------------------------------------------
                ; 
                ;------------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings", "Error", "The picture could not be loaded or does not exist.", #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              ResizeImage(#Image_Pictureofstuff_Picture, 800, 600, #PB_Image_Smooth)
              
              SetGadgetState(#Gadget_Pictureofstuff_Picture, ImageID(#Image_Pictureofstuff_Picture))
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ;
            ;--------------------------------------------------------------------------------------
            
            SetInfoBarArea("Current",  #EmptyString, CurrentRecord.s, #PB_Compiler_Procedure)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Database query failed or was empty: " + DatabaseError(), #PB_Compiler_Procedure)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; Show new record number and status in the main window
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings", "Info", Message.s  + " to the picture database", #PB_Compiler_Procedure)
          
          ;----------------------------------------------------------------------------------------
          ; Make sure the data form window is topmost
          ;----------------------------------------------------------------------------------------
          
          SetActiveWindow(#Window_Pictureofstuff)
          
          ;----------------------------------------------------------------------------------------
          ; Make sure the version field is selected
          ;----------------------------------------------------------------------------------------
          
          SetActiveGadget(#Gadget_Pictureofstuff_Picture)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The program window could not be opened.", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", "Another program window is still open, close that one first.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      ResizeImage(#Gadget_Pictureofstuff_Picture, #MainPictureWidth, #MainPictureHeight, #PB_Image_Smooth)
      
      SetInfoBarArea("Headings", "Error", "No record number found on line: " + Str(CurrentLine.i), #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Info", "There is no current line selected", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 326
; FirstLine = 288
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog