﻿;==========================================================================================================================================================
; Find, copy and relink a lost Document
;==========================================================================================================================================================

Procedure RelinkDocument()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  MissingDocument.s = GetGadgetText(#Gadget_Datasheet_Documentname)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If MissingDocument.s  <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    RelinkString.s  + "Find the original document and copy it back" + #CRLF$
    
    RelinkString.s  + "to the local program document storage area." + #CRLF$
    
    RelinkString.s  + #CRLF$ + #CRLF$

    RelinkString.s  + "The missing document is:"
    
    RelinkString.s  + #CRLF$ + #CRLF$
    
    RelinkString.s  + MissingDocument.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If MessageRequester("Relink document", RelinkString.s, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
      
      ;--------------------------------------------------------------------------------------------
      ; My local documents  D:\bangf\Documents\Everyone (Family)\Purchases, Payments & Sales\
      ;--------------------------------------------------------------------------------------------
      
      SearchDirectory.s = PathRequester("Relink Document", #EmptyString)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      LostDocument.s  = GetGadgetText(#Gadget_Datasheet_Documentname)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If SearchDirectory.s  <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetText(#Gadget_Datasheet_sStatusbar, "Searching for:  " + LostDocument.s  + " to reattach. Please wait.")
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        NewList FoundDirectories.s()
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If SearchDirectory.s <> #EmptyString
          
          If Right(SearchDirectory.s, 1) = "\"
            
            SearchDirectory.s = Left(SearchDirectory.s, Len(SearchDirectory.s) - 1)
            
          EndIf
          
          AddElement(FoundDirectories.s())
          
          FoundDirectories.s() = SearchDirectory.s
          
          IndexLevel.i = 0
          
          Repeat
            
            SelectElement(FoundDirectories.s(), IndexLevel.i)
            
            If ExamineDirectory(0, FoundDirectories.s(), "*.*")
              
              Path.s = FoundDirectories.s() + "\"
              
              While NextDirectoryEntry(0)
                
                Filename.s = DirectoryEntryName(0)
                
                Select DirectoryEntryType(0)
                    
                  Case #PB_DirectoryEntry_File
                    
                    ;------------------------------------------------------------------------------
                    ; Proceed if we got a new record number
                    ;------------------------------------------------------------------------------
                    
                    If Len(Path.s + Filename.s) <>  #FileIsEmpty
                      
                      If FileSize(Path.s + Filename.s)  <> #FileDoesNotExist
                        
                        If Filename.s = LostDocument.s
                          
                          If CopyFile(Path.s + Filename.s, Program\DocumentDirectory  + Filename.s) <> #FileNotCopied
                            
                            SetGadgetText(#Gadget_Datasheet_sStatusbar, "Found:  " + LostDocument.s  + ", copied and reattached.")
                            
                            SetGadgetColor(#Gadget_Datasheet_Documentname, #PB_Gadget_BackColor, $FFFFFF)
                            
                            ProcedureReturn
                            
                          Else
                            
                            SetGadgetText(#Gadget_Datasheet_sStatusbar, "Could not copy: " + LostDocument.s  + " lost Document to local storage.")
                            
                          EndIf
                          
                        Else
                          
                          SetInfoBarArea("Headings", "Info", "This Document is not a match yet.", #PB_Compiler_Procedure)
                          
                        EndIf
                        
                      Else
                        
                        SetInfoBarArea("Headings", "Error", "This Document does not seem to exist at the selected location.", #PB_Compiler_Procedure)
                        
                      EndIf
                      
                    Else
                      
                      SetInfoBarArea("Headings", "Error", "There is no Document string for this record.", #PB_Compiler_Procedure)
                      
                    EndIf
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                  Case #PB_DirectoryEntry_Directory
                    
                    Filename.s = DirectoryEntryName(0)
                    
                    If Filename.s <> ".." And Filename.s <> "."
                      
                      AddElement(FoundDirectories())
                      
                      FoundDirectories() = Path + Filename.s
                      
                    EndIf
                    
                EndSelect
                
              Wend
              
            EndIf
            
            IndexLevel.i + 1
            
          Until IndexLevel.i > ListSize(FoundDirectories()) -1
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Info", "Nothing to do as user has cancelled the relink.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Info", "There is no document linked to this Mystuff record.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 44
; FirstLine = 19
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog