﻿;==============================================================================================================================================================================
; Harkon
;==============================================================================================================================================================================

Procedure.l ScanPicture(wPixTypes.l, dResolution.d, reset.w)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If MessageRequester("Scan picture", "About to scan a picture for this record okay?" + #CRLF$  + "Make sure the scanner is online and working correctly.", #PB_MessageRequester_YesNoCancel) = #PB_MessageRequester_Yes
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Static PDFStarted.l
    
    Static PageNumber.l
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Define hDib.l
    
    ; Define sTempFileName.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If reset
      
      PDFStarted = 0
      
      PageNumber = 0
      
      ProcedureReturn 1
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If TWAIN_State() <> #TWAIN_SOURCE_OPEN
      
      TWAIN_OpenDefaultSource()
      
    EndIf
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Not TWAIN_GetHideUI()
      
      TWAIN_SetHideUI(1)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    TWAIN_SetCurrentResolution(dResolution)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If wPixTypes = 3      ; Colour should be 4 not 3 this is a hck fix
      
      wPixtypes = 4
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    hDib = TWAIN_AcquireNative(0, wPixTypes)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If hDib
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      PageNumber + 1
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      TemporaryFileNamePart.s = GetWindowTitle(#Window_Datasheet)
      
      Position.i              = FindString(TemporaryFileNamePart.s, "Record number: ")
      
      TemporaryFileNamePart.s = Mid(TemporaryFileNamePart.s, Position.i, Len(TemporaryFileNamePart.s))
      
      TemporaryFileNamePart.s = ReplaceString(TemporaryFileNamePart.s, ": ", "_")
      
      If FindString(TemporaryFileNamePart.s, "?") <> #NoStringFound
        
        TemporaryFileNamePart.s = ReplaceString(TemporaryFileNamePart.s, "?", #EmptyString, #PB_String_NoCase, 1)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      MyStuffEdit\PictureAndPath.s = Program\TemporaryDirectory + "Mystuff_" + TemporaryFileNamePart.s + ".jpg"
      
      hkTWAIN_WriteNativeToJPG(hdib, MyStuffEdit\PictureAndPath.s, 300)
      
      TWAIN_FreeNative(hDib)
      
      If Not PDFStarted
        
        pdf_Create("P", "in", #PDF_PAGE_FORMAT_A4)
        
        pdf_SetTitle("Scan")
        
        PDFStarted = 1
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If MyStuffEdit\PictureAndPath.s <> #EmptyString
        
        If FileSize(MyStuffEdit\PictureAndPath.s)  <> #FileDoesNotExist
          
          DatasheetPictureId.i = LoadImage(#PB_Any, MyStuffEdit\PictureAndPath.s)
          
          If DatasheetPictureId.i <> #NoPictureHandle
            
            NewImageHandle.i = ResizeImage(DatasheetPictureId.i, #DatasheetPictureWidth, #DatasheetPictureHeight, #PB_Image_Smooth)
            
            If NewImageHandle.i
              
              SetGadgetState(#Gadget_Datasheet_ItemPicture, NewImageHandle.i)
              
              SetGadgetText(#Gadget_Datasheet_Picturename,  MyStuffEdit\PictureAndPath.s)
              
            Else
              
              SetInfoBarArea("Headings",  "Error",  "Could not resize the loaded picture to the picture frame.", #PB_Compiler_Procedure)
              
            EndIf
            
          Else
            
            SetInfoBarArea("Headings",  "Error",  "The Picture requested for this stuff could not be loaded from disk.", #PB_Compiler_Procedure)
            
          EndIf
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "The Picture requested for this stuff does not exist.", #PB_Compiler_Procedure)
          
        EndIf
        
      Else
        
        SetInfoBarArea("Headings",  "Warn",  "There is no current Picture to load for this stuff.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      pdf_AddPage("P", #PDF_PAGE_FORMAT_A4)
      
      pdf_Image(MyStuffEdit\PictureAndPath.s, 0, 0, 8.5, 0)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ; DeleteFile(MyStuffEdit\PictureAndPath.s)                                  ; Delete temporary scan image
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ProcedureReturn #True
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ProcedureReturn #False
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "Nothing to do as user cancelled the picture scan.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 190
; FirstLine = 154
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP