﻿;==========================================================================================================================================================
; Show my stuff for the currently selected location, field and string
;==========================================================================================================================================================

Procedure SimpleSearch()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SearchType.s      =                      GetGadgetText(#Gadget_Mystuff_Searchtype)
  
  SearchField.s     =             RepQuote(GetGadgetText(#Gadget_Mystuff_Searchfield))
  
  SearchText.s      =             RepQuote(GetGadgetText(#Gadget_Mystuff_Searchstring))
  
  ;------------------------------------------------------------------------------------------------
  ; Special case string searches before all else
  ;------------------------------------------------------------------------------------------------
  
  Select SearchText.s
      
    Case "//nodoc"
      
      DatabaseQuery.s = "SELECT * FROM Mystuff "
      
      DatabaseQuery.s + "WHERE "
      
      DatabaseQuery.s + "Itemdocument = ''"
      
      DatabaseQuery.s + "OR "
      
      DatabaseQuery.s + "Itemdocument IS NULL"
      
    Case "//nopic"
      
      DatabaseQuery.s = "SELECT * FROM Mystuff "
      
      DatabaseQuery.s + "WHERE "
      
      DatabaseQuery.s + "Itempicture = ''"

      DatabaseQuery.s + "OR "
      
      DatabaseQuery.s + "Itempicture IS NULL"
      
    Default
      
      ;--------------------------------------------------------------------------------------------
      ; Alias the search type text to SQLite operators
      ;--------------------------------------------------------------------------------------------
      
      SearchCommand.s = SetSearchQuery(SearchType.s, SearchText)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select  SearchField
    
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
          
        Case "All fields"
          
          DatabaseQuery.s = "SELECT * FROM Mystuff "
          
          DatabaseQuery.s + " WHERE "
          
          DatabaseQuery.s + "("
          
          DatabaseQuery.s + " Itemname"           + SearchCommand.s
          
          DatabaseQuery.s + " OR Supplier"        + SearchCommand.s
          
          DatabaseQuery.s + " OR Manufacturer"    + SearchCommand.s
          
          DatabaseQuery.s + " OR Modelnumber"     + SearchCommand.s
          
          DatabaseQuery.s + " OR Serialnumber"    + SearchCommand.s
          
          DatabaseQuery.s + " OR Barcode"         + SearchCommand.s
          
          DatabaseQuery.s + " OR Boughton"        + SearchCommand.s
          
          DatabaseQuery.s + " OR Working"         + SearchCommand.s
          
          DatabaseQuery.s + " OR Whopaid"         + SearchCommand.s
          
          DatabaseQuery.s + " OR Ownername"       + SearchCommand.s
          
          DatabaseQuery.s + " OR Location"        + SearchCommand.s
          
          DatabaseQuery.s + " OR Condition"       + SearchCommand.s
          
          DatabaseQuery.s + " OR Category"        + SearchCommand.s
          
          DatabaseQuery.s + " OR Comments"        + SearchCommand.s
          
          DatabaseQuery.s + " OR Itempicture"     + SearchCommand.s
          
          DatabaseQuery.s + " OR Cost"            + SearchCommand.s
          
          DatabaseQuery.s + " OR Tax"             + SearchCommand.s
          
          DatabaseQuery.s + " OR Delivery"        + SearchCommand.s
          
          DatabaseQuery.s + " OR Othercost"       + SearchCommand.s
          
          DatabaseQuery.s + " OR Resale"          + SearchCommand.s
          
          DatabaseQuery.s + " OR Paidby"          + SearchCommand.s
          
          DatabaseQuery.s + " OR Warrantyperiod"  + SearchCommand.s
          
          DatabaseQuery.s + " OR Warrantyword"    + SearchCommand.s
          
          DatabaseQuery.s + " OR Warrantyactive"  + SearchCommand.s
          
          DatabaseQuery.s + " OR Warrantyextra"   + SearchCommand.s
          
          DatabaseQuery.s + " OR Insured"         + SearchCommand.s
          
          DatabaseQuery.s + " OR Insuredamount"   + SearchCommand.s
          
          DatabaseQuery.s + " OR Insuredon"       + SearchCommand.s
          
          DatabaseQuery.s + " OR Insurername"     + SearchCommand.s
          
          DatabaseQuery.s + " OR Policynumber"    + SearchCommand.s
          
          DatabaseQuery.s + " OR Contactnumber"   + SearchCommand.s
          
          DatabaseQuery.s + " OR Contactname"     + SearchCommand.s
          
          DatabaseQuery.s + ") "
          
        ;       DatabaseQuery.s + " OR Deleted"         + SearchCommand.s
        ;       
        ;       DatabaseQuery.s + " OR Favourite"       + SearchCommand.s
        ;       
        ;       DatabaseQuery.s + " OR Locked"          + SearchCommand.s
        ;       
        ;       DatabaseQuery.s + " OR Mystuffid"       + SearchCommand.s
          
          DatabaseQuery.s + " AND Deleted = 0 AND Locked = 0 "
          
          DatabaseQuery.s + " ORDER BY Itemname "
          
          DatabaseQuery.s + " ASC"
    
        Default      
          
          ;----------------------------------------------------------------------------------------
          ; Search all fields
          ;----------------------------------------------------------------------------------------
          
          DatabaseQuery.s = "SELECT * FROM Mystuff " 
          
          DatabaseQuery.s + " WHERE "
          
          DatabaseQuery.s + SearchField.s  + SearchCommand.s  
          
          DatabaseQuery.s + " AND Deleted = '0' AND Locked = '0' "
          
          DatabaseQuery.s + " ORDER BY Itemname "
          
          DatabaseQuery.s + " ASC"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
  
      EndSelect
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = ReplaceString(DatabaseQuery.s, Space(2), Space(1), #PB_String_NoCase, 1, 1)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ClearGadgetItems(#Gadget_Mystuff_Itemlist)
  
  ;------------------------------------------------------------------------------------------------
  ; Set the initial total item value string
  ;------------------------------------------------------------------------------------------------

  Program\TotalCost.d     = 0
  
  ;------------------------------------------------------------------------------------------------
  ; Set the initial total item value string
  ;------------------------------------------------------------------------------------------------

  SetInfoBarArea("Total",  #EmptyString, StrD(Program\TotalCost.d, 2), #PB_Compiler_Procedure)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  LineCounter.i = 0
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery.s  <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ClearGadgetItems(#Gadget_Mystuff_Itemlist)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
        
        Mystuff\Itemname          =  GetDatabaseString(Program\DatabaseHandle,  0)
        
        Mystuff\Supplier          =  GetDatabaseString(Program\DatabaseHandle,  1)
        
        Mystuff\Manufacturer      =  GetDatabaseString(Program\DatabaseHandle,  2)
        
        Mystuff\Modelnumber       =  GetDatabaseString(Program\DatabaseHandle,  3)
        
        Mystuff\Serialnumber      =  GetDatabaseString(Program\DatabaseHandle,  4)
        
        Mystuff\Barcode           =  GetDatabaseString(Program\DatabaseHandle,  5)
        
        Mystuff\Boughton          =  GetDatabaseString(Program\DatabaseHandle,  6)
        
        Mystuff\Working           =  GetDatabaseString(Program\DatabaseHandle,  7)
        
        Mystuff\Whopaid           =  GetDatabaseString(Program\DatabaseHandle,  8)
        
        Mystuff\Ownername         =  GetDatabaseString(Program\DatabaseHandle,  9)
        
        Mystuff\Location          =  GetDatabaseString(Program\DatabaseHandle, 10)
        
        Mystuff\Condition         =  GetDatabaseString(Program\DatabaseHandle, 11)
        
        Mystuff\Category          =  GetDatabaseString(Program\DatabaseHandle, 12)
        
        Mystuff\Importance        =    GetDatabaseLong(Program\DatabaseHandle, 13)
        
        Mystuff\Loanedto          =  GetDatabaseString(Program\DatabaseHandle, 14)
        
        Mystuff\Comments          =  GetDatabaseString(Program\DatabaseHandle, 15)
        
        Mystuff\Itempicture       =  GetDatabaseString(Program\DatabaseHandle, 16)
        
        Mystuff\Itemdocument      =  GetDatabaseString(Program\DatabaseHandle, 17)
        
        Mystuff\Cost              =  GetDatabaseString(Program\DatabaseHandle, 18)
        
        Mystuff\Tax               =  GetDatabaseString(Program\DatabaseHandle, 19)
        
        Mystuff\Delivery          =  GetDatabaseString(Program\DatabaseHandle, 20)
        
        Mystuff\Othercost         =  GetDatabaseString(Program\DatabaseHandle, 21)
        
        Mystuff\Resale            =  GetDatabaseString(Program\DatabaseHandle, 22)
        
        Mystuff\Paidby            =  GetDatabaseString(Program\DatabaseHandle, 23)
        
        Mystuff\Warrantyperiod    =  GetDatabaseString(Program\DatabaseHandle, 24)
        
        Mystuff\Warrantyword      =  GetDatabaseString(Program\DatabaseHandle, 25)
        
        Mystuff\Warrantyactive    =  GetDatabaseString(Program\DatabaseHandle, 26)
        
        Mystuff\Warrantyextra     =  GetDatabaseString(Program\DatabaseHandle, 27)
        
        Mystuff\Insured           =  GetDatabaseString(Program\DatabaseHandle, 28)
        
        Mystuff\Insuredamount     =  GetDatabaseString(Program\DatabaseHandle, 29)
        
        Mystuff\Insuredon         =  GetDatabaseString(Program\DatabaseHandle, 30)
        
        Mystuff\Insurername       =  GetDatabaseString(Program\DatabaseHandle, 31)
        
        Mystuff\Policynumber      =  GetDatabaseString(Program\DatabaseHandle, 32)
        
        Mystuff\Contactnumber     =  GetDatabaseString(Program\DatabaseHandle, 33)
        
        Mystuff\Contactname       =  GetDatabaseString(Program\DatabaseHandle, 34)
        
        Mystuff\Contactdepartment =  GetDatabaseString(Program\DatabaseHandle, 35)
        
        Mystuff\Deleted           =  GetDatabaseString(Program\DatabaseHandle, 36)
        
        Mystuff\Favourite         =  GetDatabaseString(Program\DatabaseHandle, 37)
        
        Mystuff\Locked            =  GetDatabaseString(Program\DatabaseHandle, 38)
        
        Mystuff\Mystuffid         =  GetDatabaseString(Program\DatabaseHandle, 39)

        DisplayMystuffString(LineCounter.i, "Add New Stuff")

        Program\TotalCost.d             + ValD(ClearCurrencyFormat(Mystuff\Cost))
        
        SetInfoBarArea("Total",  #EmptyString, StrD(Program\TotalCost.d, 2), #PB_Compiler_Procedure)
        
        LineCounter.i + 1
        
      Wend
      
      FinishDatabaseQuery(Program\DatabaseHandle)
      
    Else
      
      SetInfoBarArea("Headings",  "Error", "Database query failed or returned no data:  " + DatabaseError(), #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info", "No location specified, nothing to do now.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(#Gadget_Mystuff_Searchstring, #EmptyString)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 314
; FirstLine = 307
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP
; HideErrorLog