﻿;================================================================================================================================================================================
; Read the system preferences file or create it if missing
;================================================================================================================================================================================

Procedure ReadOptionData()
  
  ;------------------------------------------------------------------------------------------------
  ; Retrieve the program options from the database
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = "SELECT * "
  
  DatabaseQuery.s + "FROM Options "
  
  DatabaseQuery.s + "WHERE Optionid = 1"
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle) <> #DatabaseQueryEmpty
      
      Option\Snapformtoborders    = GetDatabaseLong(Program\DatabaseHandle, 1)  ; Snapformtoborders
      
      Option\Showtitlebarclock    = GetDatabaseLong(Program\DatabaseHandle, 2)  ; Showtitlebarclock
      
      Option\Tooltipsonoroff      = GetDatabaseLong(Program\DatabaseHandle, 3)  ; Tooltipsonoroff
      
      Option\Stickwindowontop     = GetDatabaseLong(Program\DatabaseHandle, 4)  ; Stickwindowontop
      
      Option\Colourbandinlist     = GetDatabaseLong(Program\DatabaseHandle, 5)  ; Colourbandinlist
      
      Option\Messageaftersave     = GetDatabaseLong(Program\DatabaseHandle, 6)  ; Messageaftersave
      
    Wend
    
  Else
    
    MessageRequester("Table read error", "Could not read option data table from Mystuff database.", #PB_MessageRequester_Ok)
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 40
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP