﻿;==========================================================================================================================================================
; 
;==========================================================================================================================================================
; Title: Font Preview ComboBox
; Author: Fluid Byte
; Created: January 26, 2009
; Updated: January 27, 2009
; Test-Platform: Windows XP SP3

;EnableExplicit

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Declare EnumFontsProc(*lpelfe.ENUMLOGFONTEX, *lpntme.NEWTEXTMETRICEX, FontType, lParam)

Declare EnumFonts(Gadget.i)

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Structure FONTDATA
  Type.b
  Symbol.b
  Name.s
EndStructure

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Global NewList ftd.FONTDATA(), himlFontType

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

UseJCALG1Packer()

Define *lpBuffer

;==========================================================================================================================================================
; Load packed image from memory
;==========================================================================================================================================================

*lpBuffer = AllocateMemory(406)

UncompressMemory(?FontType, ?FontTypeEnd - ?FontType, *lpBuffer, MemorySize(*lpBuffer), #PB_PackerPlugin_JCALG1)

CatchImage(0, *lpBuffer)

FreeMemory(*lpBuffer)

;==========================================================================================================================================================
; Create ImageList
;==========================================================================================================================================================

himlFontType = ImageList_Create_(16, 12, #ILC_MASK, 0, 0)

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

ImageList_AddMasked_(himlFontType, ImageID(0), #Yellow)

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Procedure EnumFontsProc(*lpelfe.ENUMLOGFONTEX,*lpntme.NEWTEXTMETRICEX,FontType,lParam)
  
  Protected CHRSET = *lpelfe\elfLogFont\lfCharSet & 255
  
  ; WESTERN FONTS / SYSTEM FONTS / SYMBOL FONTS
  
  If CHRSET = #ANSI_CHARSET Or CHRSET = #OEM_CHARSET Or CHRSET = #SYMBOL_CHARSET
    
    AddElement(ftd())
    
    Select FontType
        
      Case #TRUETYPE_FONTTYPE : ftd()\Type = 0
        
      Case #DEVICE_FONTTYPE   : ftd()\Type = 1
        
      Case #RASTER_FONTTYPE   : ftd()\Type = 2
        
      Default : ftd()\Type = -1
        
    EndSelect
    
    If CHRSET = #SYMBOL_CHARSET : ftd()\Symbol = 1 : EndIf
    
      ; Using 'lfFaceName' of the LOGFONT structure gives unique fontnames and avoids dublicates.
      ; When using 'elfFullName' of the ENUMLOGFONTEX structure you still can get dublicates even
      ; though you limit the character set like above. Also you don't need to cycle through the
      ; whole LinkedList everytime to find out if a fontname already exists.
      ; The created fontlist SHOULD be identical to the one in MS Wordpad + bitmap fonts (Courier, etc.)
      
      ftd()\Name = PeekS(@*lpelfe\elfLogFont\lfFaceName)
      
    EndIf
    
    ProcedureReturn #True
    
EndProcedure

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Procedure EnumFonts(Gadget.i)
  
  Protected lplf.LOGFONT, hdc, Index.i
  
  lplf\lfCharset = #DEFAULT_CHARSET
  
  hdc = GetDC_(0)
  
  EnumFontFamiliesEx_(hdc,lplf,@EnumFontsProc(),hdc,0)
  
  ReleaseDC_(0,hdc)
  
  SortStructuredList(ftd(), #PB_Sort_Ascending, OffsetOf(FONTDATA\Name), #PB_String)
  
  ForEach ftd()
    
    If Left(ftd()\Name, 1) = "@"
      
      DeleteElement(ftd())
      
    Else
      
      AddGadgetItem(Gadget.i, -1, ftd()\Name)
      
      SetGadgetItemData(Gadget.i, Index.i, ftd())
      
      Index.i + 1
      
    EndIf
    
  Next
  
EndProcedure

;==========================================================================================================================================================
; Data section
;==========================================================================================================================================================

DataSection
   FontType:
   Data.l $0196434A,$3E3F0000,$A9B9266D,$146B20D0,$CA126809,$0C48B008,$80C79825,$09801720,$00782062,$60707CC0
   Data.l $38050812,$08090281,$0F017800,$0E003FF0,$00AE024C,$6AA85027,$E2EFEC01,$96E700CE,$A65C7B48,$80BC3260
   Data.l $88C3BB00,$77324AE1,$4EF262C0,$B80E4B2E,$8062C31D,$4A6DC296,$5980BDDE,$2257F369,$26DC1186,$83236C5A
   Data.l $2C35A0A3,$A5E71821,$7654AD10,$05A6360C,$4155AB69,$1809D849,$A3029E26,$30C111BD,$ED52A892,$C1125BAA
   Data.l $15C6B842,$0C0DCC50,$0EC21B6C,$48A08103,$36D81083,$64D9928C,$30C5786D,$2EDAE406,$280CBC8C,$178CD766
   Data.l $B79164B0,$830B3013,$301297BC,$1820604C,$4480C3DA,$00000042
   Data.b $00,$00
   FontTypeEnd:
 EndDataSection
 
; typedef struct tagLOGFONT {
;   LONG  lfHeight;
;   LONG  lfWidth;
;   LONG  lfEscapement;
;   LONG  lfOrientation;
;   LONG  lfWeight;
;   BYTE  lfItalic;
;   BYTE  lfUnderline;
;   BYTE  lfStrikeOut;
;   BYTE  lfCharSet;
;   BYTE  lfOutPrecision;
;   BYTE  lfClipPrecision;
;   BYTE  lfQuality;
;   BYTE  lfPitchAndFamily;
;   TCHAR lfFaceName[LF_FACESIZE];
; } LOGFONT, *PLOGFONT;

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 136
; FirstLine = 131
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP