﻿;==============================================================================================================================================================================
; Freak, Srod, Sparkie, Richedit handling
;==============================================================================================================================================================================

Declare.i CatchRTF(Gadget, MemoryAddress)                                                             ; Load an RTF text file from datasection and put it into the editorgadget (By Freak I think)
Declare   CatchRTF_Callback(dwCookie, pbBuff, cb, *pcb.LONG)                                          ; Callback used by CatchRFT to stream an RTF text file fron datasection and put it into the editorgadget
Declare   GetRTF(Gadget.i, Address.i)                                                                 ; Stream the RTF data from the requested gadget
Declare.i GetRTFCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)                                       ; Callback for the RTF stream requester
Declare.i GetRTFLen(Gadget.i)                                                                         ; Get the length of RTF data in the requested gadget
Declare.i GetRTFLenCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)                                    ; Callback for the RTF length retriever
Declare.s GetRtfData(Gadget)                                                                          ; Get RTF data from the requested gadget

;==========================================================================================================================================================
; RASHAD
;==========================================================================================================================================================

Declare EditorColour(Gadget.i, TextColour.i)                                                          ; Colour found string in editorgadgets
Declare Clearselections(TextColour.i)                                                                 ; Clear previous colour selections
Declare SearchAndColour(Gadget.i, TextColour.i, TextString.s)                                         ; Search for and colour target strings

;==========================================================================================================================================================
; Thirdparty modules. Some are compilations of procedures and/or variables that cannot be declared here
;==========================================================================================================================================================

;Declare   NM_Hover()                                                                                  ; NetMaestro's Hover library
;Declare   KM_RatingGadget()                                                                           ; Kenmo's rating gadget procedures, data etc
;Declare   SR_EditableListIconGadget()                                                                 ; Srod's editable ListIconGadget code
;Declare   FB_OwnerDrawComboFonts()                                                                    ; Fluid Byte's owner drawn combo box
;Declare   NL_SortListIcongadget()                                                                     ; Nalor and Dige's sort ListIconGadget rows
;Declare   HK_PurePDF 2_25()                                                                           ; Harkon's conversion of ABBKlaus's PDF creation code

;==========================================================================================================================================================
; Generic modules used by all programs
;==========================================================================================================================================================

Declare   AllowOnly(Gadget.i, CharacterSet.i)                                                         ; Prevent certain predefined characters being entered into string gadgets
Declare.s ByteCalc(Byte.q, NbDecimals.i = 2)                                                          ; AND51's correct file size calculation code
Declare.s ClearCurrencyFormat(CurrencyString.s)                                                       ; Clear the currency formatting characters as they are not stored in the database
Declare   CleanDirectory(Directory.s)                                                                 ; Clean a directory and all of its files no matter what attribute they have
Declare.s FormatMenu(HeadingString.s, ShortcutString.s, FieldLen.i)                                   ; Format menu text and shortcut strings to nice length
Declare.s FormatField(InString.s, FieldLen.i)                                                         ; Format the passed string to the correct field length for printing
Declare.s FormatNumber(NumberText.s, Position.i = 3)                                                  ; Format a number with commas in the right place. BasicallyPure
Declare.s GetCurrency(CurrencyIn.s)                                                                   ; Format the currency correctly according to the locality
Declare.s GetShortcutText(Constant.i)                                                                 ; Get the text of the associated shortcut constant. SROD
Declare.i GetWindowTitleBarDetails(Window.i)                                                          ; Get the current windows title bar height. Useful for form element resizing.
Declare   LastLine(Gadget.i, LineNumber.i)                                                            ; Go to the last line of a ListIconGadget
Declare.s MakeSureDirectoryPathExists(Directory.s)                                                    ; Need a unicode aware version of the API directory creator
Declare   MixedComboCaseEx(Gadget.i)                                                                  ; First letter uppercase in a combo box. srod!.
Declare   MixedStringCase(Gadget.i)                                                                   ; First letter uppercase in a string box. srod!
Declare.s ProperCaseString(StringToBeFlipped.s)                                                       ; Flip a mixed string into all proper case
Declare   RemoveBorders(GadgetConstant.i)                                                             ; Remove borders from various gadgets
Declare   StringFirstUpper(GadgetId.i)                                                                ; Convert the first character of a string to uppercase
Declare.s TextToXML(TextString.s)                                                                     ; Replace bad characters with XML compatible ones. Thorsten Hoeppner
Declare.s XMLToText(XMLString.s)                                                                      ; Strip illegal characters from text strings

;==============================================================================================================================================================================
; Custom procedures
;==============================================================================================================================================================================

Declare   BalloonToolTip(pbWindowNumber.i, pbGadgetNumber.i, pbFontHandle.i, balloonColour.i, balloonTipTitle.s, balloonTipText.s,  pbIconHandle.i) ; Add balloon tooltips with individual fonts and icons
Declare   CloseMyWindow(WindowId.i)                                                                   ; Close the window and reset the mutex
Declare   ChangeSearchCue(WindowName.s)                                                               ; Change the search cue text when field names change in combo boxes
Declare.i GetIconHandle(ImageConstant.i)                                                              ; Copy the icon into memory while deleting the original image copied from. RASHAD's modification
Declare.s IsoDate(DateString.s, Direction.s)                                                          ; Convert an ISO format date to Australian and back
Declare   SelectFocusGadget()                                                                         ; Select which gadgets is used when the user presses Return
Declare   SetDate(WindowId.i)                                                                         ; Sort out the date and display it
Declare   SetInfoBarArea(FieldName.s, FieldStatus.s = "##Error##", MessageContent.s = "0", ModuleName.s = "") ; Send messages and error reports to the fake status bar area
Declare   SetHoverIcons(Gadget.i, Image.i, State.s)                                                   ; Set the correct icons to the selected hoverable gadget
Declare   SetSearchCue(CueText.s, StringGadget.i, ComboGadget.i = 0)                                  ; Setup the search box cue text
Declare   StatusBarButtonTip(WindowNumber.i, ButtonItem.s)                                            ; Set and display button toolbar/menu text in the statusbar
Declare   TitleBarClock(ObjectHandle.i, Message.i, EventNumber.i, TimePeriod.i)                       ; Run an asynchronous clock in the window title bar
Declare   WindowCallback(WindowID, Message, wParam, lParam)                                           ; Window snap, strikeoutfont and more
Declare   WriteErrorLog(ModuleName.s = "", Message.s = "")                                            ; Write the error log to disk in the temporary directory
Declare.s WordWrapString(SourceString.s, StringWidth.i, DelimiterList.s = "- " + Chr(9), NewLineString.s = #LF$)  ; Wrap a string to a specified boundary

;==========================================================================================================================================================
; Main thing to do at system start
;==========================================================================================================================================================

Declare.s CountRecords(TableField.s, TableName.s, ExtraArguments.s = "")                              ; Count the number of records in an SQLite database
Declare.s DatabaseLastInsertRowId()                                                                   ; Get the ID of the last inserted record
Declare   FillCombo(Gadget.i, DatabaseQuery.s, ColumnIcon.i = 0)                                      ; Fill a combobox gadget from a linked list, SQLite version
Declare.s KillQuote(Instring.s)                                                                       ; Kill double quotes in strings for display purposes
Declare.s LastRecord(TableField.s, TableName.s)                                                       ; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
Declare   OpenSystemDatabase()                                                                        ; Open the main program database
Declare.s RepQuote(Instring.s)                                                                        ; Uncle Berikco's routine to properly replace single quotes with double for SQL passing
Declare.s SetSearchQuery(SearchOperator.s, SearchString.s)                                            ; Alias the search type text to SQLite operators

;==============================================================================================================================================================================
; Setup and options
;==============================================================================================================================================================================

Declare   ReadOptionData()                                                                            ; Read all preference data from disk

;==========================================================================================================================================================
; All program toggles
;==========================================================================================================================================================

Declare   ToggleScreenSnap()                                                                          ; Turn border snap on and off as needed
Declare   ToggleShowClock()                                                                           ; Turn time updating on in the title bar
Declare   ToggleToolTips()                                                                            ; Turn tool tips on and off as needed
Declare   ToggleStickyWindow()                                                                        ; Turn sticking on top of other windows on or off
Declare   ToggleColourBand()                                                                          ; Turn alternate list display banding on or off
Declare   ToggleMessageSave()                                                                         ; Turn save messages on of off

;==============================================================================================================================================================================
; Hiding program to the task bar and showing it again
;==============================================================================================================================================================================

Declare   HideProgramWindow()                                                                         ; Hide the program window
Declare   ShowProgramWindow()                                                                         ; Show the program window

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Declare   Backupmystuff()                                                                             ; Create dated backups of your database
Declare   Deleteallmystuff()                                                                          ; Delete all tables and data in mystuff database
Declare   Vacuummystuff()                                                                             ; Vacuum wasted space in the database from killed entries
Declare   Exportmystuff()                                                                             ; Export all my stuff to the temporary directory
Declare   ImportMyStuff()                                                                             ; Import an XML file of Mystuff entries
Declare   ImportMystuffNode(*CurrentNode, CurrentSublevel.i)                                          ; Decode Mystuff node data

Declare   ImportMyDocuments()                                               ; Administrative only     ; Mass document import from selected directory

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Declare   Addlocation()                                                                               ; Add a new location to the location bar
Declare   Copylocation()                                                                              ; Copy the current location to the clipboard
Declare   DeleteLocation()                                                                            ; Delete an existing location from the location bar
Declare   EditLocation()                                                                              ; Edit the current location and update the mystuff entries for that location
Declare   ExportLocations()                                                                           ; Export current locations to a text file on disk
Declare   ImportLocations()                                                                           ; Import locations from a text file on disk
Declare   SaveLocation()                                                                              ; Save the new or edsited location data

Declare   GetLocations()                                                                              ; Load the standard locations and user defined ones from the database
Declare   Sortlocations()                                                                             ; Sort the locations alphabetically when saved
Declare   UpdateLocationItemCount(LocationName.s)                                                     ; Update the Location itemcount field each time we add, change or delete locations

;==========================================================================================================================================================
; Handling of my stuff
;==========================================================================================================================================================

Declare   AddNewStuff()                                                                               ; Add new stuff to my home inventory list
Declare   CopyOldStuff()                                                                              ; Copy my current stuff to the system clipboard
Declare   DeleteOldStuff()                                                                            ; Mark the selected stuff as deleted
Declare   EditOldStuff()                                                                              ; Edit an older item in my stuff
Declare   FavouriteStuff()                                                                            ; Mark this stuff as a favourite
Declare   KillThisStuff()                                                                             ; Permanently delete the current stuff
Declare   LockThisStuff()                                                                             ; Lock the currently selected stuff
Declare   PrintThisStuff()                                                                            ; Print a report of the currently selected stuff
Declare   Pictureofstuff()                                                                            ; Show a bigger version of the stored picture

Declare   SaveMyStuff()                                                                               ; Save the new or edited stuff

Declare   AddNewPicture()                                                                             ; Add a new Picture to the old or edited record
Declare   ClearOldPicture()                                                                           ; Clear the existing picture from the display and name field
Declare   DeleteOldPicture()                                                                          ; Delete the existing picture from the display, name field and local storage
Declare.l ScanPicture(wPixTypes.l, dResolution.d, reset.w)                                            ; Scan a Picture into the current record

Declare   LookupModel()                                                                               ; Lookup the model number and manufacturer in your browser

Declare   LoadOldPicture(Picturename.s)                                                               ; Load a linked Picture for the passed picture name

Declare   AddNewDocument()                                                                            ; Load a linked Document for the passed  name
Declare   ViewDocument()                                                                              ; View the attached document on top of the data sheet
Declare   RelinkDocument()                                                                            ; Find, copy and relink a lost Document

Declare.l AquireDocument(wPixTypes.l, dResolution.d, reset.w)                                         ; Aquire a document image from the scanner
Declare   ScanDocument()                                                                              ; Scan an  into the current record
Declare   ScanNextDocumentPage()                                                                      ; Scan the next document page
Declare   SaveScannedDocumentPages()                                                                  ; Save the scanned document pages

Declare   DisplayMystuffString(LineNumber.i, DisplayMode.s)                                           ; Handle all list display jobs from add, edit, list, import modes etc
Declare   DisplayMystuffDetails()                                                                     ; Show the current record on the status bar area

Declare   GetMyStuffForLocation()                                                                     ; Show my stuff for the currently selected location

Declare   SimpleSearch()                                                                              ; Show my stuff for the currently selected location, field and string

;==========================================================================================================================================================
; Help and information
;==========================================================================================================================================================

Declare   Aboutmystuff()                                                                              ; Mystuff 'About' window
Declare   Keyboardshortcuts()                                                                         ; Show a list of all the keyboard shortcuts
Declare   Statisticsformystuff()                                                                      ; Show statistics about the current database

;==========================================================================================================================================================
; Miscellaneous
;==========================================================================================================================================================

Declare   OneTimeLocationUpdateCount()                                      ; Administrative only    ; One off routine to update the ItemCount field in the Location table from the Location field in the Mystuff table

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 135
; FirstLine = 124
; EnableAsm
; EnableUnicode
; EnableXP